#!/usr/local/bin/ruby -Ks

#--------------------------------------------------------
# Ruby for ACS Analyzer             ver1.10c RR 2007-2009
# analyze
#
# url   : http://www.runread.com/
# e-mail: info@runread.com
#--------------------------------------------------------
STDOUT.sync=true

require 'settings.rb'
require 'common.rb'
require 'execute.rb'
require 'log.rb'
require 'user.rb'
require 'net/http'
require 'kconv'
require 'date'


USER = User.new



begin

Cgi = CGI.new



class Analyze

extend Common
extend Execute

protected
  #--- J_[ -----------------------------
  def Analyze.calendar(mode, type, apage, sdate, edate, item, key, ope)
    st = Date.new(sdate[0].to_i, sdate[1].to_i, 1).cwday
    if st == 7 then st = 0; end
    ed = 31
    while !Date.exist?(sdate[0].to_i, sdate[1].to_i, ed)
      ed -= 1
    end
    
    daterange = (sdate[0] + sdate[1] + sdate[2])..(edate[0] + edate[1] + edate[2])
    
    cellcnt = ((st + ed) / 7.0).ceil * 7
    
    thtml = ''
    c = 0
    cellcnt.times{|i|
      if c == 0 then thtml += '<tr>'; end
      
      if i >= st && i <= ed + st - 1
        thtml += '<td align="center" ' + ((daterange.include?(sdate[0] + sdate[1] + (sprintf("%02d", i - st + 1)))) ? ('bgcolor="' + GRAPH_BACK_COLOR + '"') : ('')) + '>' +
                 '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + 
                                                '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sprintf("%02d", i - st + 1) + 
                                                '&ey=' + sdate[0] + '&em=' + sdate[1] + '&ed=' + sprintf("%02d", i - st + 1) + 
                                                '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '">' +
                  (i - st + 1).to_s + 
                 '</a></td>'
      else
        thtml += '<td>@</td>'
      end
      
      if c < 6
        c += 1
      else
        thtml += '</tr>'
        c = 0
      end
    }
    
    nextday = self.adjust_date(sdate, 1)
    prevday = self.adjust_date(sdate, -1)
    nextmon = self.adjust_date(sdate, 1, true)
    prevmon = self.adjust_date(sdate, -1, true)
    
    chtml =
    
    '<table border="0" cellpadding="0" cellspacing="0" align="center" width="150"><tbody>
    <tr>' +
    '<td align="center"><a title="Ǒ" href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + prevmon[0] + '&sm=' + prevmon[1] + '&sd=' + prevmon[2] + '&ey=' + prevmon[0] + '&em=' + prevmon[1] + '&ed=' + edate[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '">&lt;&lt;</a></td>' +
    '<td align="center"><a title="O̓" href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + prevday[0] + '&sm=' + prevday[1] + '&sd=' + prevday[2] + '&ey=' + prevday[0] + '&em=' + prevday[1] + '&ed=' + prevday[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '">&lt;</a></td>' +
    '<td align="center">' + sdate[0] + '-' + sdate[1] + '</td>' +
    '<td align="center"><a title="̓" href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + nextday[0] + '&sm=' + nextday[1] + '&sd=' + nextday[2] + '&ey=' + nextday[0] + '&em=' + nextday[1] + '&ed=' + nextday[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '">&gt;</a></td>' +
    '<td align="center"><a title="̌" href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + nextmon[0] + '&sm=' + nextmon[1] + '&sd=' + nextmon[2] + '&ey=' + nextmon[0] + '&em=' + nextmon[1] + '&ed=' + edate[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '">&gt;&gt;</a></td>' +
    '</tr>
    </tbody></table>' +
    
    
    '<table border="1" cellpadding="0" cellspacing="0" align="center" width="150"><tbody>
    <tr>
    <td bgcolor="' + WEEK_BACK_COLOR + '" align="center"><font color="#ff0000"></font></td>
    <td bgcolor="' + WEEK_BACK_COLOR + '" align="center"></td>
    <td bgcolor="' + WEEK_BACK_COLOR + '" align="center"></td>
    <td bgcolor="' + WEEK_BACK_COLOR + '" align="center"></td>
    <td bgcolor="' + WEEK_BACK_COLOR + '" align="center"></td>
    <td bgcolor="' + WEEK_BACK_COLOR + '" align="center"></td>
    <td bgcolor="' + WEEK_BACK_COLOR + '" align="center"><font color="#0000ff">y</font></td>
    </tr>' +
    
    thtml +
    
    '</tbody></table>'
  end

  #--- tf[^̒ -----------------------
	def Analyze.adjust_date(dates, num, mon = false)
    begin 
      if mon
        date = Date.new(dates[0].to_i, dates[1].to_i, dates[2].to_i) >> num
      else
        date = Date.new(dates[0].to_i, dates[1].to_i, dates[2].to_i) + num
      end
      date.strftime("%Y %m %d").split(' ')
    rescue
      self.error('݂ȂtłI')
    end
  end

  #--- OC -------------------------------
  def Analyze.login(password)
  	Net::HTTP.version_1_2
    
    if password != PASSWORD
    	self.error('OCpX[hႢ܂I')
    end
    
    if Log.delete_limit						                #~bg𒴂 Ot@C&ID ̍폜
      User.delete_limit
    end
    
    cookie1 = CGI::Cookie::new({'name' => 'password', 'value' => password, 'expires' => Time.now + COOKIE_TIME})
    cookie2 = CGI::Cookie::new({'name' => 'session_pass', 'value' => password})
    
		#Net::HTTP.start(ENV['HTTP_HOST'], 80){|http|
    #	response = http.get(ENV['SCRIPT_NAME'] + "?mode=explain", {"Cookie" => "session_pass=" + password + ";", "Content-type" => "application/x-www-form-urlencoded"})
			
    #  Cgi.out("cookie" => [cookie1, cookie2]){ response.body }
    #}
    
    Cgi.out("cookie" => [cookie1, cookie2]){		#̂ł̓ANZXoȂȂ̂(T[o[̐H)meta^ÕtbVőp
    	'<html>
			 <head>
       <meta http-equiv="Refresh" content="0;URL=' + ANALYZE_SCRIPT + '?mode=explain">
			 <title></title>
			 </head>' + BODY_HTML + '</body>
			 </html>'
    }
  end

  #--- OC ---------------------------
  def Analyze.show_login
  	password = Cgi.cookies['password'][0] || ''
  
  	html = self.header
  	
    html +=
    				'<table border="1" cellpadding="0" cellspacing="0" align="center" width="380"><tbody>' +
            
            '<tr>' +
            '<td colspan="2">' + ANALYZER_TITLE_HTML + '</td>' +
    				'</tr>' +
            '<tr>' +
            '<td align="center" colspan="2"><div class="cell_menu"><center>ADMIN LOGIN</center></div></td>' +
            '</tr>' +
            
            '<form action="' + ANALYZE_SCRIPT + '" method="POST">' +
            '<input type="hidden" name="mode" value="login">' +
            
            '<tr>' +
            '<td bgcolor="' + BODY_COLOR + '">@</td><td bgcolor="' + BODY_COLOR + '">@</td>' +
            '</tr>' +
           	'<tr>' +
            '<td bgcolor="' + BODY_COLOR + '">Password: </td><td bgcolor="' + BODY_COLOR + '"><input type="password" name="password" size="32" value="' + password + '">(p 4`16)</td>' +
            '</tr>' +
            '<tr>' +
            '<td bgcolor="' + BODY_COLOR + '">@</td><td bgcolor="' + BODY_COLOR + '">@</td>' +
            '</tr>' +
            
            '<tr>' +
            '<td align="center" colspan="2" bgcolor="' + BODY_COLOR + '"><input type="submit" value="M"></td>' +
            '</tr>' +
            
            '</form>' +
            
            '</tbody></table>'
    
    
    acdate = self.safe_read(DATA_DIR + '/ac_date' + DATA_EXT).split('-')
    begin
      acdate = Date.new(acdate[0].to_i, acdate[1].to_i, acdate[2].to_i)
    rescue
      acdate = Date.new(2009, 1, 1)
    end
    date = Time.now.strftime("%Y-%m-%d").split('-')
    date = Date.new(date[0].to_i, date[1].to_i, date[2].to_i)
    
    if date - acdate >= 1
      Net::HTTP.start('data.runread.com', 80){|http|
        response = http.get('/datas/current_data/adsense.txt')
        self.safe_write(DATA_DIR + '/adsense' + DATA_EXT, 'w', response.body)

        http.get('/datas/user_info/user.cgi?mode=count&app=aanalyzer&ver=' + VERSION + '&pass=cEg03fFeJdwmWGrQRt')
    	  
        response = http.get('/datas/current_data/aanalyzer/version.txt')
			  if response.body > VERSION
          response = http.get('/datas/current_data/aanalyzer/history.txt')
      
          html += '<br><br><br>' +
                  '<table border="1" cellpadding="0" cellspacing="0" align="center" width="380"><tbody>' +
                  '<tr><td align="center" bgcolor="' + BODY_COLOR + '">' +
                  '<font color="' + ITEM_COLOR + '"><b>Vo[WJĂ܂</b></font>' +
                  '<br><br>' +
                  response.body.gsub(/\n/, '<br>') +
                  '<br>' +
                  '<a href="http://www.runread.com/">_E[h</a>' +
                  '</td></tr>' +
                  '<tbody></table>'
        end
      }
      
      self.safe_write(DATA_DIR + '/ac_date' + DATA_EXT, 'w', date.strftime("%Y-%m-%d"))
    end
 
  	html += self.footer
    
    Cgi.out{ html }
  end
  
  #---  -------------------------------
  def Analyze.explain
  	mhtml = '<table border="0" cellpadding="0" cellspacing="0" align="left" width="100%" height="100%"><tbody>' +
    				
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>ANZX͍</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ANZX͂̊eڂɂĂ̊ȒPȐłB</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>ANZXO</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ANZXO\܂B<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">OF ANZXO\܂B</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ODLF ANZXO_E[hEۑo܂B</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>ANZXv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ANZXlΏۂɂ͂łB"Jn""I"Ŏw肵ΏۂɏWv܂B<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ԕʁF ANZXԕʂɏWv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ʁF ANZXʂɏWv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ʁF ANZXʂɏWv̂łB</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>Nv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">NΏۂɂ͂łB<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">NURLF NURLΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">NhCF NhCΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">GWF ŇGWΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">L[[hF y[WꂽL[[hΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>VXev</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">K҂̃VXeΏۂɂ͂łB<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">uEUF uEUΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">OSF OS̎ނΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ʁF ʏ(@c@F)Ώۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">CookieF Cookie(NbL[)LWv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">JavascriptF JavascriptLWv̂łB</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>Kғv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">K҂̊eΏۂɂ͂łB<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">[U[IDF [U[IDΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">zXgF zXgΏۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">K񐔁F K񐔂Ώۂɑ̂Wv̂łB</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>TCgv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">TCgURLΏۂɂ͂łB<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">lCy[WF ANZX̑y[WWv̂łB</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">y[WIDʁF y[WIDʂɃANZXWv̂łB</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">s܂B<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">OF w肳ꂽڂƃL[[hŃO܂B</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>eݒ</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">eݒ肪s܂<br><hr size="1"></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">y[WIDҏWF y[WIDҏW܂BOɋL^Ăy[WID͎IɖۑƂĕ\܂B</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">ef[^ҏWF ͂Ŏgpẽf[^ҏWo܂B</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td width="100%" height="100%" bgcolor="' + BODY_COLOR + '"></td>' +
            '</tr>' +
            
    				'</tbody></table>'
  end
  
  #--- O\ -----------------------------
  def Analyze.log(mode, type, apage, sdate, edate, page)
		page = page.to_i

		thtml = ''
    
    log = Log.new(sdate, edate, apage)
    
    si = SHOW_LOG_COUNT * page
    ei = (log.size > si + SHOW_LOG_COUNT) ? (si + SHOW_LOG_COUNT) : (log.size)
    
    log[si...ei].each{|v|
    	(date, id, host, ip, alyzpage, pid, referer, useragent,
    	 screen, js, ck, os, browser, srchengin, keyword, reserved) = v.split('<>')
       
       unescaperef = CGI.unescape(CGI.escapeHTML(referer)).tosjis
       alyzpage = CGI.escapeHTML(alyzpage)
        
        	if type == 'simple'
          	thtml += '<tr>' +
        						 '<td width="27%"><div class="cell_menu"><b>' + date + '</b></div></td><td><div class="cell_menu" style="text-align: right">' + ((PAGE_NAMES[pid].size > 50) ? (PAGE_NAMES[pid][0..50] + '...') : (PAGE_NAMES[pid])) + ' [' + pid + ']@</div></td>' +
          	  		   '</tr>' +
            			   '<tr>' +
            		  	 '<td colspan="2">' +
        				  	 '<div class="cell_body">' +
        						 '<font color="' + ITEM_COLOR + '">IDF </font>' +
                     '<a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                      '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                      '&apage=' + apage + '&item=2&key=' + id + '">#</a>' +
                                                                      
                     ' ' + id + '@<font color="' + ITEM_COLOR + '">{񐔁F </font>' + USER[id.to_i].to_a[0].to_s + '@<font color="' + ITEM_COLOR + '">ʁF </font>' + CGI.escapeHTML(screen) + '@<font color="' + ITEM_COLOR + '">OSF </font>' + ((os != 'Unknown') ? (os.split('|')[1]) : (os)) + '@<font color="' + ITEM_COLOR + '">uEUF </font>' + browser + '<br>' +
                   	 '<font color="' + ITEM_COLOR + '">zXgF </font>' +
                     '<a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                      '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                      '&apage=' + apage + '&item=3&key=' + host + '">#</a>' +
                                                                      
                     ' ' + '<a href="' + JUMP_SCRIPT + '?ip=' + host + '" target="_blank">' + host + '</a>@<font color="' + ITEM_COLOR + '">IPF </font>' + ip + '<br>' +
                   	 '<font color="' + ITEM_COLOR + '">t@[F </font><a href="' + JUMP_SCRIPT + '?url=' + CGI.escape(referer) + '" target="_blank">' + ((unescaperef.size <= 75) ? (unescaperef) : (unescaperef[0..75] + '...')) + '</a><br>' +
                   	 '<font color="' + ITEM_COLOR + '">UserAgentF </font>' + CGI.escapeHTML(useragent) + 
                     
                     '<div style="text-align: right;">' +
                     
                     '<form style="margin: 2px;" action="' + ANALYZE_SCRIPT + '" method="GET">
                     <input type="hidden" name="mode" value="check">
                     <input type="hidden" name="type" value="delete_log">
                     <input type="hidden" name="apage" value="' + apage + '">
                     <input type="hidden" name="date" value="' + date + '">
                     <input type="hidden" name="uid" value="' + id + '">
                     <input type="hidden" name="pid" value="' + pid + '">
                     <input type="hidden" name="sy" value="' + sdate[0] + '">
                     <input type="hidden" name="sm" value="' + sdate[1] + '">
                     <input type="hidden" name="sd" value="' + sdate[2] + '">
                     <input type="hidden" name="ey" value="' + edate[0] + '">
                     <input type="hidden" name="em" value="' + edate[1] + '">
                     <input type="hidden" name="ed" value="' + edate[2] + '">
                     <input type="submit" value="폜" style="width:34; height:18; border-style:solid; border-width:1px; border-color:' + MENU_COLOR + '; color:' + BODY_TEXT_COLOR + '; background:' + BODY_BACK_COLOR + ';">
                     </form>' +
                     
=begin
                     '<a href="' + ANALYZE_SCRIPT + '?mode=check&type=delete_log&apage=' + apage + '&date=' + date + '&uid=' + id + '&pid=' + pid +
                                                   '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      						 	                               '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '">폜</a>' +
=end
                     '</div>' +
                     
                     '</div>' +
                     '</td>' +
            	       '</tr>' +
							 	 
                     '<tr><td colspan="2"><br></td></tr>'
          else
          	thtml += '<tr>' +
        						 '<td nowrap width="120"><div class="cell_menu"><b>K⎞ԁF </b></div></td><td><div class="cell_menu">' + date + '</div></td>' +
          	  		   '</tr>' +
            			   '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">[U[IDF </font></div></td><td><div class="cell_body">' + 
                     '<a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                      '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                      '&apage=' + apage + '&item=2&key=' + id + '">#</a>' +
                     ' ' + id + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">zXgF </font></div></td><td><div class="cell_body">' +
                     '<a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                      '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                      '&apage=' + apage + '&item=3&key=' + host + '">#</a>' +
                                                             
                     ' ' + '<a href="' + JUMP_SCRIPT + '?ip=' + host + '" target="_blank">' + host + '</a></div><td>' +
                     '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">IPAhXF </font></div></td><td><div class="cell_body">' + ip + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">̓y[WF </font></div></td><td><div class="cell_body">' + ((PAGE_NAMES[pid].size < 70) ? (PAGE_NAMES[pid]) : (PAGE_NAMES[pid][0..70] + '...')) + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">NGXgURLF </font></div></td><td><div class="cell_body">' + ((alyzpage.size < 70) ? (alyzpage) : (alyzpage[0..70] + '...')) + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">y[WIDF </font></div></td><td><div class="cell_body">' + pid + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td bgcolor="' + BODY_COLOR + '" nowrap width="120"><font color="' + ITEM_COLOR + '">Qƌy[WF </font></div></td><td bgcolor="' + BODY_COLOR + '"><a href="' + JUMP_SCRIPT + '?url=' + CGI.escape(referer) + '" target="_blank">' + ((unescaperef.size <= 70) ? (unescaperef) : (unescaperef[0..70] + '...')) + '</a><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td bgcolor="' + BODY_COLOR + '" nowrap width="120"><font color="' + ITEM_COLOR + '">[UG[WFgF </font></td><td bgcolor="' + BODY_COLOR + '">' + CGI.escapeHTML(useragent) + '<td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td bgcolor="' + BODY_COLOR + '" nowrap width="120"><font color="' + ITEM_COLOR + '">GWF </font></div></td><td bgcolor="' + BODY_COLOR + '">' + srchengin.to_s + '<td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td bgcolor="' + BODY_COLOR + '" nowrap width="120"><font color="' + ITEM_COLOR + '">L[[hF </font></div></td><td bgcolor="' + BODY_COLOR + '">' + CGI.unescape(keyword.to_s).tosjis + '<td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">uEU[F </font></div></td><td><div class="cell_body">' + browser + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">OSF </font></div></td><td><div class="cell_body">' + os + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">{񐔁F </font></div></td><td><div class="cell_body">' + USER[id.to_i].to_a[0].to_s + ' </div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">ʏF </font></div></td><td><div class="cell_body">' + CGI.escapeHTML(screen) + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">JavaScriptF </font></div></td><td><div class="cell_body">' + js + '</div><td>' +
                   	 '</tr>' +
                     '<tr>' +
      							 '<td nowrap width="120"><div class="cell_body"><font color="' + ITEM_COLOR + '">CookieF </font></div></td><td><div class="cell_body">' + ck + '</div><td>' +
                   	 '</tr>' +
                     '</tr>' +
                     
                     '<tr>' +
      							 '<td colspan="2">' + 
                     '<div class="cell_body" style="text-align: right">' +
                     
                     '<form style="margin: 2px;" action="' + ANALYZE_SCRIPT + '" method="GET">
                     <input type="hidden" name="mode" value="check">
                     <input type="hidden" name="type" value="delete_log">
                     <input type="hidden" name="apage" value="' + apage + '">
                     <input type="hidden" name="date" value="' + date + '">
                     <input type="hidden" name="uid" value="' + id + '">
                     <input type="hidden" name="pid" value="' + pid + '">
                     <input type="hidden" name="sy" value="' + sdate[0] + '">
                     <input type="hidden" name="sm" value="' + sdate[1] + '">
                     <input type="hidden" name="sd" value="' + sdate[2] + '">
                     <input type="hidden" name="ey" value="' + edate[0] + '">
                     <input type="hidden" name="em" value="' + edate[1] + '">
                     <input type="hidden" name="ed" value="' + edate[2] + '">
                     <input type="submit" value="폜" style="width:34; height:18; border-style:solid; border-width:1px; border-color:' + MENU_COLOR + '; color:' + BODY_TEXT_COLOR + '; background:' + BODY_BACK_COLOR + ';">
                     </form>' +
                     
                     '</div>' +
                     '<td>' +
                   	 '</tr>' +
							 	 
                     '<tr><td colspan="2"><br></td></tr>'
          end
    }
    
    mhtml = '<div class="cell_back" style="height: 100%">' +
    				'<table border="0" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
            '<tr><td colspan="2"><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>ANZXO@(' + sdate[0] + 'N' + sdate[1] + '' + sdate[2] + '`' +
            																																						    								edate[0] + 'N' + edate[1] + '' + edate[2] + ')</div></td></tr>' +
            '</tbody></table>' +
            
            '<table border="0" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
            '<tr><td colspan="2"><br></td></tr>' +
                                                                                            
            '<tr><td colspan="2"><table border="1" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
            '<tr><td align="center">' + log.size.to_s + '</td></tr>'
            
    mhtml += '<tr><td align="center">'
    pages = (((log.size < 1) ? (1) : (log.size)) / SHOW_LOG_COUNT.to_f).ceil
    pages.times{|i|
    	if i != page
      	mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      					 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    	else
      	mhtml += '<b>' + (i + 1).to_s + '</b> '
      end
    }
    mhtml += '</td></tr>' +	
             '</tbody></table></td></tr>' +
             '<tr><td colspan="2"><br></td></tr>'
    
    mhtml += thtml
 		
    mhtml += '<tr><td colspan="2"><table border="1" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
    				 '<tr><td align="center">'
    pages.times{|i|
    	if i != page
      	mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      					 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    	else
      	mhtml += '<b>' + (i + 1).to_s + '</b> '
      end
    }
    mhtml += '</td></tr>' +
             '</tbody></table></td></tr>' +
             '<tr><td colspan="2"><br></td></tr>'
   
    mhtml += '</tbody></table></div>'
  end
  
  #--- ANZXv -------------------------
  def Analyze.count(mode, type, apage, sdate, edate)
		istr = {'time'=>['Hour','',' AM',' PM'],'day'=>['Day','',' ',' '],'month'=>['Month','',' ',' ']}

    mhtml = '<div class="cell_back" style="height: 100%"><table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
            '<tr>' +
        	  '<td><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>ANZXv@(' + sdate[0] + 'N' + sdate[1] + '' + sdate[2] + '`' +
            																																						                                edate[0] + 'N' + edate[1] + '' + edate[2] + ')</div></td>' +
          	'</tr>' +
            
            '<tr>' +
        	  '<td><div class="cell_body">' + istr[type][1] + 'ʃANZX̓v\܂B</div></td>' +
          	'</tr>'
    
    cnt = 0
    ids = {}
    hids = {}
    hit = {}
    uhit = {}
    tuhit = 0
    max = 0
    typecnt = 0
    
    datecnt = 1
    date = [[sdate[0].to_i, sdate[1].to_i, sdate[2].to_i],
            [edate[0].to_i, edate[1].to_i, edate[2].to_i]]
    
    now = Time.now
    nd = Date.new(now.year, now.month, now.day)
      
    while !Date.exist?(date[0][0], date[0][1], date[0][2])
      date[0][2] -= 1
    end
    while !Date.exist?(date[1][0], date[1][1], date[1][2])
      date[1][2] -= 1
    end
    
    sd = Date.new(date[0][0], date[0][1], date[0][2])
    ed = Date.new(date[1][0], date[1][1], date[1][2])
    
    if ed - nd > 0
      ed -= (ed - nd)
    end

   	case type
    	when 'time'
        typecnt = 24
        datecnt = (ed - (sd - 1)) * 24
        if nd - ed <= 0
          datecnt -= 24 - (now.hour + 1)
        end
      when 'day'
        typecnt = 31
        datecnt = (ed - (sd - 1))
      when 'month'
        typecnt = 12
        datecnt = ((ed.year - sd.year) + 1) * 12
        datecnt -= sd.month - 1
        datecnt -= 12 - ed.month
    end
 
    Log.new(sdate, edate, apage).each{|v|
    	(date, id) = v.split('<>')
    	
    		cnt += 1
        n = nil
        ni = nil
        
        case type
        	when 'time'
            ni = date[/^\d+\-\d+\-\d+ \d+/]
            if mode == 'count_v'
        		  n = date.split(' ')[1].split(':')[0].to_i
            else
              n = ni
            end
        	when 'day'
            ni = date.split(' ')[0]
            if mode == 'count_v'
          	  n = date.split(' ')[0].split('-')[2].to_i - 1
            else
              n = ni
            end
          when 'month'
            ni = date.split(' ')[0][/^\d+\-\d+/]
            if mode == 'count_v'
          	  n = date.split(' ')[0].split('-')[1].to_i - 1
            else
              n = ni
            end
        end
        
        if hit[n] == nil then hit[n] = 0; end
        if uhit[n] == nil then uhit[n] = 0; end
        if hids[ni] == nil then hids[ni] = []; end
          
        ids[id] = true
        
        hit[n] += 1
        if !hids[ni].include?(id)
          uhit[n] += 1
        	hids[ni].push(id)
        end
    }

    max = hit.values.max.to_i
    
    uhit.each_value{|v| tuhit += v.to_i }
    
    #11, 54
    tdwidth = 11 + 7 * cnt.to_s.size
    tdwidth2 = 54 + 7 * sprintf("%0.2f", cnt.to_f / datecnt).split('.')[0].size
    
    mhtml += '<tr>' +
             '<td><div class="cell_body">' +
             '<table border="0" cellpadding="0" cellspacing="0">' +
             '<td width="88">qbg</td><td width="' + tdwidth.to_s + '">F ' + cnt.to_s + '</td>' + 
             '<td width="20" align="center">|</td>' + 
             '<td width="' + tdwidth2.to_s + '">ρF ' + sprintf("%.2f", cnt.to_f / datecnt) + '</td>' +
             '<td width="20" align="center">|</td>' + 
             '</table>' +
             '</div></td>' +
             '</tr>' +
             
             '<tr>' +
        	   '<td><div class="cell_body">' + 
             '<table border="0" cellpadding="0" cellspacing="0">' +
             '<td width="88">j[N(' + istr[type][1][0..1] + ')</td><td width="' + tdwidth.to_s + '">F ' + tuhit.to_s + '</td>' +
             '<td width="20" align="center">|</td>' + 
             '<td width="' + tdwidth2.to_s + '">ρF ' + sprintf("%.2f", tuhit.to_f / datecnt) + '</td>' +
             '<td width="20" align="center">|</td>' + 
             '</table>' +
             '</div></td>' +
             '</tr>' +
             
             '<tr>' +
        	   '<td><div class="cell_body">' +
             '<table border="0" cellpadding="0" cellspacing="0">' +
             '<td width="88">j[N(S)</td><td width="' + tdwidth.to_s + '">F ' + ids.size.to_s + '</td>' + 
             '<td width="20" align="center">|</td>' + 
             '<td width="' + tdwidth2.to_s + '">ρF ' + sprintf("%.2f", ids.size.to_f / datecnt) + '</td>' +
             '<td width="20" align="center">|</td>' + 
             '</table>' +
             '</div></td>' +
          	 '</tr>' +
             
             '<tr>' +
        	   '<td>'


case mode
  when 'count_h'

    mhtml += '<div class="cell_body">' +
    				 '<table border="1" cellpadding="0" cellspacing="0" align="center" width="100%"><tbody>' +
    				 '<tr>' +
             
             '<td width="17%" align="right"></td>' +
             '<td width="18%" align="right">j[N</td>' +
             '<td width="18%" align="right">qbg</td>' +
             
             '<td width="47%" align="right">' +
             '<table border="0" cellpadding="0" cellspacing="0" width="100%">' +
             '<tr>' +
             '<td align="left">' + '&nbsp;' + istr[type][0] + '</td>' +
             '<td align="right">' + max.to_s + '</td>' +
             '</tr>' +
             '</table>' +
             '</td>' +
             
             '</tr>'
    
    t = 0
    while true
      case type
        when 'time'
          dstr = sd.strftime("%Y-%m-%d ") + sprintf("%02d", t)
          if ed >= nd && sd >= nd && t > now.hour
            break
          elsif sd > ed
            break
          end
          if t < 23
            t += 1
          else
            sd += 1
            t = 0
          end
        when 'day'
          dstr = sd.strftime("%Y-%m-%d")
          if sd > ed then break; end
          sd += 1
        when 'month'
          dstr = sd.strftime("%Y-%m")
          
          s = sd.strftime("%Y%m").to_i
          e = ed.strftime("%Y%m").to_i
          
          if s > e then break; end
          sd = sd >> 1
      end
      
      if hit[dstr] == nil then hit[dstr] = 0; end
      if uhit[dstr] == nil then uhit[dstr] = 0; end
      
      ug = ((max > 0) ? (287 * uhit[dstr] / max.to_f) : (0))
      ag = ((max > 0) ? (287 * hit[dstr] / max.to_f - ug) : (0))
      
      mhtml += '<tr>' +
               '<td bgcolor="' + CELL_BACK_COLOR + '">' +
               '<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>' +
               '<td><a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                    '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                    '&apage=' + apage + '&item=1&key=' +
                                                                    '&quot;' + dstr + '&quot;' + '">#</a></td>' +
               '<td align="right">' +
               dstr +
               '</td>' +
               '</table>' +
               '</td>' +
               
               '<td bgcolor="' + CELL_BACK_COLOR + '" align="right">' + uhit[dstr].to_s + '</td>' + 
               '<td bgcolor="' + CELL_BACK_COLOR + '" align="right">' + hit[dstr].to_s + '</td>' +
               '<td bgcolor="' + GRAPH_BACK_COLOR + '">'
      
      if ug > 0
        mhtml += '<img src="image/u_graph_h' + GRAPH_COLOR_NUM + '.jpg" height="14" width="' + ug.to_s + '" title="' + uhit[dstr].to_s + '">'
      end
      if ag > 0
        mhtml += '<img src="image/graph_h' + GRAPH_COLOR_NUM + '.jpg" height="14" width="' + ag.to_s + '" title="' + hit[dstr].to_s + '">'
      end
      if ug <= 0 && ag <= 0 then mhtml += '&nbsp;'; end #IEñGW̏ꍇAe[u̘gFςĂ܂̂łŏC
      
      mhtml += '</td>' +
               '</tr>'
    end

    mhtml += '</td>' +
             '</tr>' +
             
             '</table></div>'

        
  when 'count_v'
             
    mhtml += '<div class="cell_body">' + 
             '<table border="0" cellpadding="0" cellspacing="0" align="center"><tbody>' +
             '<tr>'


    mhtml += '<td width="40" height="100%" align="right" valign="top">' +
             
             '<table border="0" cellpadding="0" cellspacing="0" align="right" valign="top" height="100%"><tbody>' +
             '<tr><td align="right" valign="top">' + max.to_s + '</td></tr>' +
             '<tr><td align="right" valign="bottom">' + istr[type][0] + '</td></tr>' +
             '</tbody></table>' +
             
             '</td>' +
            
             '<td width="5"></td>' + 
             '<td>' +
             '<div class="cell_body2" style="height: 165px">' +
      			 '<table border="0" cellpadding="0" cellspacing="0" align="center"><tbody>' +
             '<tr>'

    typecnt.times{|i|
      if hit[i] == nil then hit[i] = 0; end
      if uhit[i] == nil then uhit[i] = 0; end
    
    	ug = ((max > 0) ? (150 * uhit[i] / max.to_f) : (0))
      ag = ((max > 0) ? (150 * hit[i] / max.to_f - ug) : (0))
    	
      mhtml += '<td width="17" height="150" align="center" valign="bottom">'
      
      if ag > 0
      	mhtml += '<img src="image/graph_v' + GRAPH_COLOR_NUM + '.jpg" width="14" height="' + ag.to_s + '" title="' + hit[i].to_s + '"><br>'
    	end
      if ug > 0
      	mhtml += '<img src="image/u_graph_v' + GRAPH_COLOR_NUM + '.jpg" width="14" height="' + ug.to_s + '" title="' + uhit[i].to_s + '">'
    	end
      
      mhtml += '</td>'
    }
    
    mhtml += '<tr>'
    
    typecnt.times{|i|
			mhtml += '<td width="17" align="center" valign="bottom">' + ((type == 'time') ? (i.to_s) : ((i + 1).to_s)) + '</td>'    
    }
    
    mhtml += '</tr>' +
    				 '</tr>' +
             '</tbody></table></div>' +
             '</td>' +
             '<td width="40"></td>' +
             '</tr>' +
             '</tbody></table></div>' +
             '</div>' +
             '</td>' +
          	 '</tr>'
    
    mhtml += '<tr><td><div class="cell_body">' +
    				 '<table border="1" cellpadding="0" cellspacing="0" align="center" width="100%"><tbody>' +
    				 '<tr>' +
             '<td width="8%" align="right">' + istr[type][1] + '</td><td width="21%" align="right">j[N</td><td width="21%" align="right">qbg</td>' +
             '<td width="8%" align="right">' + istr[type][1] + '</td><td width="21%" align="right">j[N</td><td width="21%" align="right">qbg</td>' +
             '</tr>'
    
    half = (typecnt / 2.0).ceil
    half.times{|i|
    	mhtml += '<tr>' +
    					 '<td bgcolor="' + CELL_BACK_COLOR + '">' +
               '<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>' +
               '<td><a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                    '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                    '&apage=' + apage + '&item=1&key=' +
                                                                    ((type == 'time') ? (sprintf("&quot; %02d:&quot;", i)) : ((type == 'day') ? (sprintf("&quot;-%02d &quot;", i + 1)) : (sprintf("&quot;-%02d-&quot;", i + 1)))) + '">#</a></td>' +
               '<td align="right">' +
               ((type == 'time') ? (i.to_s + istr[type][2]) : ((i + 1).to_s) + istr[type][2]) + 
               '</td>' +
               '</tr></table>' +
               '</td>' +
               
               '<td align="right" bgcolor="' + CELL_BACK_COLOR + '">' + 
               uhit[i].to_s + 
               '</td>' +
               '<td align="right" bgcolor="' + CELL_BACK_COLOR + '">' + 
               hit[i].to_s + 
               '</td>'
    	
      if hit.key?(i + half)
      	mhtml += '<td bgcolor="' + CELL_BACK_COLOR + '">' + 
                 '<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>' +
                 '<td><a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                    '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                    '&apage=' + apage + '&item=1&key=' +
                                                                    ((type == 'time') ? (sprintf("&quot; %02d:&quot;", i + half)) : ((type == 'day') ? (sprintf("&quot;-%02d &quot;", i + half + 1)) : (sprintf("&quot;-%02d-&quot;", i + half + 1)))) + '">#</a></td>' +
                 '<td align="right">' +
                 ((type == 'time') ? (i.to_s + istr[type][3]) : ((i + half + 1).to_s) + istr[type][2]) + 
                 '</td>' +
                 '</tr></table>' +
                 '</td>' +
                 
                 '<td align="right" bgcolor="' + CELL_BACK_COLOR + '">' + 
                 uhit[i + half].to_s + 
                 '</td>' +
                 '<td align="right" bgcolor="' + CELL_BACK_COLOR + '">' + 
                 hit[i + half].to_s + 
                 '</td>'
    	else
      	mhtml += '<td align="right" bgcolor="' + CELL_BACK_COLOR + '">@</td><td align="right" bgcolor="' + CELL_BACK_COLOR + '">@</td><td align="right" bgcolor="' + CELL_BACK_COLOR + '">@</td>'
      end
      
      mhtml += '</tr>'
    }

end


    mhtml += '</tbody></table>' +
    				 '</div></td></tr></tbody></table></div>'

  end
  
  #--- Nv ---------------------------
  def Analyze.link(mode, type, apage, sdate, edate, page)
    title = {'url'=>['NURLv', 'URL'], 'domain'=>['NhCv', 'hC'],
             'engin'=>['GWv', 'GW'], 'keyword'=>['L[[hv', 'L[[h'],
             'phrase'=>['t[Yv', 't[Y']}
    
    page = page.to_i
    cnt = 0
    hdata = {}
    
    Log.new(sdate, edate, apage).each{|v|
    	(date, id, host, ip, alyzpage, pid, referer, useragent,
    	 screen, js, ck, os, browser, srchengin, keyword, reserved) = v.split('<>')

        case type
        	when 'url'
          	cnt += 1
        		if referer == ''
        			referer = 'NoReferer'
        		end
        		hdata[referer] = hdata[referer].to_i
        		hdata[referer] += 1
          when 'domain'
          	cnt += 1
            if referer == ''
        			referer = 'NoReferer'
        		end
            referer.gsub!(/http:\/\/([\w\d\.\-]+).*/, '\1')
        		hdata[referer] = hdata[referer].to_i
        		hdata[referer] += 1
        	when 'engin'
          	if srchengin.to_s != ''
            	cnt += 1
              hdata[srchengin] = hdata[srchengin].to_i
              hdata[srchengin] += 1
            end
          when 'keyword'
            if keyword.to_s != ''
            	cnt += 1
              keyword = CGI.unescape(keyword).tosjis
              keyword.split(/ |@/).each{|v|
                if v == '' then next; end
                hdata[v] = hdata[v].to_i
                hdata[v] += 1
              }
            end
          when 'phrase'
            if keyword.to_s != ''
            	cnt += 1
              keyword = CGI.unescape(keyword).tosjis
              hdata[keyword] = hdata[keyword].to_i
              hdata[keyword] += 1
            end
        end
    }
 
    adata = hdata.to_a.sort{|a, b| (b[1] <=> a[1]).nonzero? || a[0] <=> b[0] }
  
    mhtml = '<div class="cell_back" style="height: 100%"><table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
            '<tr>' +
        	  '<td colspan="2"><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>' + title[type][0] + '@(' + sdate[0] + 'N' + sdate[1] + '' + sdate[2] + '`' +
            																																						    						     edate[0] + 'N' + edate[1] + '' + edate[2] + ')</div></td>' +
    				'</tr>' +
            '<tr>' +
    				'<td colspan="2"><div class="cell_body">͑Ώۃqbg񐔁F ' + cnt.to_s + '</div></td>' +
          	'</tr>' +
            '<tr>' +
    				'<td width="540"><div class="cell_body" style="text-align: center">' + title[type][1] + '</div></td><td><div class="cell_body" style="text-align: right"></div></td>' +
          	'</tr>'
   
    si = SHOW_ITEM_COUNT * page
    ei = (adata.size > si + SHOW_ITEM_COUNT) ? (si + SHOW_ITEM_COUNT) : (adata.size)
    
    adata[si...ei].each{|v|
      if (type == 'url' || type == 'domain') && v[0] != 'NoReferer' && v[0] != 'NoScript'
        unescapea = CGI.unescape(CGI.escapeHTML(v[0])).tosjis
        mhtml += '<tr>' +
      	         '<td><div class="cell_body"><a href="' + JUMP_SCRIPT + '?url=' + CGI.escape(v[0]) + '" target="_blank">' + ((unescapea.size < 78) ? (unescapea) : (unescapea[0..78] + '...')) + '</a></div></td><td nowrap><div class="cell_body" style="text-align: right">' + v[1].to_s + '(' + sprintf("%2.2f", ((v[1] / cnt.to_f) * 100)) + '%)</div></td>' +
               	 '</tr>'
      else
        mhtml += '<tr>' +
      	         '<td><div class="cell_body">' + ((v[0].size < 78) ? (v[0]) : (v[0][0..78] + '...')) + '</div></td><td nowrap><div class="cell_body" style="text-align: right">' + v[1].to_s + '(' + sprintf("%2.2f", ((v[1] / cnt.to_f) * 100)) + '%)</div></td>' +
               	 '</tr>'
    	end
    }
           
    mhtml += '</tbody></table><br>'
  
  	pages = (((adata.size < 1) ? (1) : (adata.size)) / SHOW_ITEM_COUNT.to_f).ceil
  
  	if pages > 1
    	mhtml += '<table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
    					 '<tr><td align="center">'
    	pages.times{|i|
    		if i != page
      		mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      						 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    		else
      		mhtml += '<b>' + (i + 1).to_s + '</b> '
      	end
    	}
    	mhtml += '</td></tr>' +
      				 '</tbody></table><br>'
    end
             
    mhtml += '</div>'

  end
  
  #--- VXev ---------------------------
  def Analyze.system(mode, type, apage, sdate, edate, page)
    title = {'browser_simple'=>['uEUv', 'uEU'], 'browser_detail'=>['uEUv', 'uEU'], 'os_simple'=>['OSv', 'OS'], 'os_detail'=>['OSv', 'OS'], 'screen'=>['ʓv', ''], 'js'=>['JavaScriptv', 'JavaScript'], 'cookie'=>['Cookiev', 'Cookie']}
    
    page = page.to_i
    cnt = 0
    hdata = {}
    
    Log.new(sdate, edate, apage).each{|v|
    	(date, id, host, ip, alyzpage, pid, referer, useragent,
    	 screen, js, ck, os, browser, srchengin, keyword, reserved) = v.split('<>')
    	
        case type
        	when 'browser_simple'
            cnt += 1
          
            bh = nil
            BROWSER_NAMES.each{|v|
              if browser[/#{v[0]}/]
                bh = v[1]
                break
              end
            }
            
            if bh == nil
              bh = (browser[/([^\/]+)/]) ? ($1) : ('Unknown')
            end
            
            hdata[bh] = hdata[bh].to_i
            hdata[bh] += 1
          when 'browser_detail'
            cnt += 1
        		hdata[browser] = hdata[browser].to_i
        		hdata[browser] += 1
          when 'os_simple'
          	cnt += 1
        		if os != 'Unknown'
            	os = os.split('|')[1]
            end
        		hdata[os] = hdata[os].to_i
        		hdata[os] += 1
          when 'os_detail'
          	cnt += 1
        		if os != 'Unknown'
            	os = os.split('|')[0]
            end
        		hdata[os] = hdata[os].to_i
        		hdata[os] += 1
          when 'screen'
          	cnt += 1
        		hdata[screen] = hdata[screen].to_i
        		hdata[screen] += 1
          when 'js'
          	cnt += 1
        		hdata[js] = hdata[js].to_i
        		hdata[js] += 1
          when 'cookie'
          	cnt += 1
        		hdata[ck] = hdata[ck].to_i
        		hdata[ck] += 1
        end
    }
 
    adata = hdata.to_a.sort{|a, b| (b[1] <=> a[1]).nonzero? || a[0] <=> b[0] }
  
    mhtml = '<div class="cell_back" style="height: 100%"><table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
            '<tr>' +
        	  '<td colspan="2"><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>' + title[type][0] + '@(' + sdate[0] + 'N' + sdate[1] + '' + sdate[2] + '`' +
            																																						    						     edate[0] + 'N' + edate[1] + '' + edate[2] + ')</div></td>' +
    				'</tr>' +
            '<tr>' +
    				'<td colspan="2"><div class="cell_body">͑Ώۃqbg񐔁F ' + cnt.to_s + '</div></td>' +
          	'</tr>' +
            '<tr>' +
    				'<td width="540"><div class="cell_body" style="text-align: center">' + title[type][1] + '</div></td><td><div class="cell_body" style="text-align: right"></div></td>' +
          	'</tr>'
    
    si = SHOW_ITEM_COUNT * page
    ei = (adata.size > si + SHOW_ITEM_COUNT) ? (si + SHOW_ITEM_COUNT) : (adata.size)
    
    adata[si...ei].each{|v|
      v[0] = CGI.escapeHTML(v[0])
      mhtml += '<tr>' +
               '<td><div class="cell_body">' + ((v[0].size < 78) ? (v[0]) : (v[0][0..78] + '...')) + '</div></td><td nowrap><div class="cell_body" style="text-align: right">' + v[1].to_s + '(' + sprintf("%2.2f", ((v[1] / cnt.to_f) * 100)) + '%)</div></td>' +
               '</tr>'
    }
             
    mhtml += '</tbody></table><br>'
  
  	pages = (((adata.size < 1) ? (1) : (adata.size)) / SHOW_ITEM_COUNT.to_f).ceil
  
  	if pages > 1
    	mhtml += '<table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
    					 '<tr><td align="center">'
    	pages.times{|i|
    		if i != page
      		mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      						 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    		else
      		mhtml += '<b>' + (i + 1).to_s + '</b> '
      	end
    	}
    	mhtml += '</td></tr>' +
      				 '</tbody></table><br>'
    end
             
    mhtml += '</div>'
    
  end
  
  #--- Kғv -----------------------------
  def Analyze.visitor(mode, type, apage, sdate, edate, page)
  	title = {'uid'=>['[U[IDv', '[U[ID'], 'host'=>['zXgv', 'zXg'], 'vcount'=>['K񐔓v', 'K']}
    
    page = page.to_i
    cnt = 0
    hdata = {}
    vcdata = {}
    
    Log.new(sdate, edate, apage).each{|v|
    	(date, id, host, ip, alyzpage, pid, referer, useragent,
    	 screen, js, ck, os, browser, srchengin, keyword, reserved) = v.split('<>')
    	
        case type
        	when 'uid'
          	cnt += 1
        		hdata[id] = hdata[id].to_i
        		hdata[id] += 1
          when 'host'
          	cnt += 1
        		if host == ''
        			host = 'Unknown'
        		end
        		hdata[host] = hdata[host].to_i
        		hdata[host] += 1
          when 'vcount'
          	if USER[id.to_i]
            	cnt += 1
            	cs = USER[id.to_i][0].to_s
        			vcdata[cs] = vcdata[cs].to_i
            	vcdata[cs] += 1
        		end
        end
    }
		
    if type == 'vcount'
    	range = [[1,3],[4,8],[9,15],[16,25],[26,35],[36,55],
      			   [56,85],[86,100],[101,150],[151,200],[201,350],
               [351,500],[501,1000],[1001,1500],[1501,2300],
               [2301,3000],[3001,4000],[4001,5000],[5001,7000],[7001,10000]]
      
      range.each{|a|
    		vcdata.each{|k, v|
      		if k.to_i <= a[1]
          	hdata[a[0].to_s + '-' + a[1].to_s] = hdata[a[0].to_s + '-' + a[1].to_s].to_i
          	hdata[a[0].to_s + '-' + a[1].to_s] += v
            vcdata.delete(k)
          end
      	}
        
        if vcdata.size == 0
        	break
        end
      }
      
      if vcdata.size > 0
      	hdata['10000-'] = vcdata.size
      end
    end
   	
    adata = hdata.to_a.sort{|a, b| (b[1] <=> a[1]).nonzero? || a[0] <=> b[0] }
  	
    mhtml = '<div class="cell_back" style="height: 100%"><table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
            '<tr>' +
        	  '<td colspan="2"><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>' + title[type][0] + '@(' + sdate[0] + 'N' + sdate[1] + '' + sdate[2] + '`' +
            																																						    						     edate[0] + 'N' + edate[1] + '' + edate[2] + ')</div></td>' +
    				'</tr>' +
            '<tr>' +
    				'<td colspan="2"><div class="cell_body">͑Ώۃqbg񐔁F ' + cnt.to_s + '</div></td>' +
          	'</tr>' +
            '<tr>' +
    				'<td width="540"><div class="cell_body" style="text-align: center">' + title[type][1] + '</div></td><td><div class="cell_body" style="text-align: right"></div></td>' +
          	'</tr>'
    
    si = SHOW_ITEM_COUNT * page
    ei = (adata.size > si + SHOW_ITEM_COUNT) ? (si + SHOW_ITEM_COUNT) : (adata.size)
    
    adata[si...ei].each{|v|
      if type == 'host'
        mhtml += '<tr>' +
      	         '<td><div class="cell_body"><a href="' + JUMP_SCRIPT + '?ip=' + v[0] + '" target="_blank">' + ((v[0].size < 78) ? (v[0]) : (v[0][0..78] + '...')) + ((type=='vcount') ? (' ') : ('')) + '</a></div></td><td nowrap><div class="cell_body" style="text-align: right">' + v[1].to_s + '(' + sprintf("%2.2f", ((v[1] / cnt.to_f) * 100)) + '%)</div></td>' +
            	   '</tr>'
      else
    	  mhtml += '<tr>' +
      	         '<td><div class="cell_body">' + ((v[0].size < 78) ? (v[0]) : (v[0][0..78] + '...')) + ((type=='vcount') ? (' ') : ('')) + '</div></td><td nowrap><div class="cell_body" style="text-align: right">' + v[1].to_s + '(' + sprintf("%2.2f", ((v[1] / cnt.to_f) * 100)) + '%)</div></td>' +
            	   '</tr>'
    	end
    }
             
    mhtml += '</tbody></table><br>'
  
  	pages = (((adata.size < 1) ? (1) : (adata.size)) / SHOW_ITEM_COUNT.to_f).ceil
  
  	if pages > 1
    	mhtml += '<table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
    					 '<tr><td align="center">'
    	pages.times{|i|
    		if i != page
      		mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      						 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    		else
      		mhtml += '<b>' + (i + 1).to_s + '</b> '
      	end
    	}
    	mhtml += '</td></tr>' +
      				 '</tbody></table><br>'
    end
             
    mhtml += '</div>'
  
  end
  
  #--- TCgv -----------------------------
  def Analyze.site(mode, type, apage, sdate, edate, page)
  	title = {'popular'=>['lCy[Wv', 'lCy[W'], 'pid'=>['y[WIDʓv', 'y[WID']}
    
    page = page.to_i
    cnt = 0
    hdata = {}
    
    if type == 'pid'
    	PAGE_NAMES.each{|k, v|
      	hdata[k] = 0
      }
    end
    
    Log.new(sdate, edate, apage).each{|v|
    	(date, id, host, ip, alyzpage, pid, referer, useragent,
    	 screen, js, ck, os, browser, srchengin, keyword, reserved) = v.split('<>')
    	
        case type
        	when 'popular'
          	cnt += 1
        		hdata[alyzpage] = hdata[alyzpage].to_i
        		hdata[alyzpage] += 1
          when 'pid'
          	cnt += 1
        		hdata[pid] = hdata[pid].to_i
        		hdata[pid] += 1
        end
    }
   	
    adata = hdata.to_a.sort{|a, b| (b[1] <=> a[1]).nonzero? || a[0] <=> b[0] }
  	
    mhtml = '<div class="cell_back" style="height: 100%"><table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
            '<tr>' +
        	  '<td colspan="2"><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>' + title[type][0] + '@(' + sdate[0] + 'N' + sdate[1] + '' + sdate[2] + '`' +
            																																						    						     edate[0] + 'N' + edate[1] + '' + edate[2] + ')</div></td>' +
    				'</tr>' +
            '<tr>' +
    				'<td colspan="2"><div class="cell_body">͑Ώۃqbg񐔁F ' + cnt.to_s + '</div></td>' +
          	'</tr>' +
            '<tr>' +
    				'<td width="540"><div class="cell_body" style="text-align: center">' + title[type][1] + '</div></td><td><div class="cell_body" style="text-align: right"></div></td>' +
          	'</tr>'
    
    si = SHOW_ITEM_COUNT * page
    ei = (adata.size > si + SHOW_ITEM_COUNT) ? (si + SHOW_ITEM_COUNT) : (adata.size)
    
    adata[si...ei].each{|v|
      v[0] = CGI.escapeHTML(v[0])
      mhtml += '<tr>' +
               '<td><div class="cell_body">' + ((v[0].size < 78) ? (v[0]) : (v[0][0..78] + '...')) + '</div></td><td nowrap><div class="cell_body" style="text-align: right">' + v[1].to_s + '(' + sprintf("%2.2f", ((v[1] / cnt.to_f) * 100)) + '%)</div></td>' +
               '</tr>'
    }
             
    mhtml += '</tbody></table><br>'
  
  	pages = (((adata.size < 1) ? (1) : (adata.size)) / SHOW_ITEM_COUNT.to_f).ceil
  
  	if pages > 1
    	mhtml += '<table border="1" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
    					 '<tr><td align="center">'
    	pages.times{|i|
    		if i != page
      		mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      						 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    		else
      		mhtml += '<b>' + (i + 1).to_s + '</b> '
      	end
    	}
    	mhtml += '</td></tr>' +
      				 '</tbody></table><br>'
    end
             
    mhtml += '</div>'
    
  end
  
  #---  -----------------------------------
  def Analyze.search(mode, type, apage, sdate, edate, item, key, ope, page)
		page = page.to_i
    thtml = ''
    
    log =  Log.new(sdate, edate, apage).search(item, key, ope)
    
    si = SHOW_LOG_COUNT * page
    ei = (log.size > si + SHOW_LOG_COUNT) ? (si + SHOW_LOG_COUNT) : (log.size)
    
    log[si...ei].each{|v|
    	(date, id, host, ip, alyzpage, pid, referer, useragent,
    	 screen, js, ck, os, browser, srchengin, keyword, reserved) = v.split('<>')
       
       unescaperef = CGI.unescape(CGI.escapeHTML(referer)).tosjis
        
          	thtml += '<tr>' +
        						 '<td width="27%"><div class="cell_menu"><b>' + date + '</b></div></td><td><div class="cell_menu" style="text-align: right">' + ((PAGE_NAMES[pid].size > 50) ? (PAGE_NAMES[pid][0..50] + '...') : (PAGE_NAMES[pid])) + ' [' + pid + ']@</div></td>' +
          	  		   '</tr>' +
            			   '<tr>' +
            		  	 '<td colspan="2">' +
        				  	 '<div class="cell_body">' +
        						 '<font color="' + ITEM_COLOR + '">IDF </font>' + 
                     '<a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                      '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                      '&apage=' + apage + '&item=2&key=' + id + '">#</a>' +
                     
                     ' ' + id + '@<font color="' + ITEM_COLOR + '">{񐔁F </font>' + USER[id.to_i].to_a[0].to_s + '@<font color="' + ITEM_COLOR + '">ʁF </font>' + CGI.escapeHTML(screen) + '@<font color="' + ITEM_COLOR + '">OSF </font>' + ((os != 'Unknown') ? (os.split('|')[1]) : (os)) + '@<font color="' + ITEM_COLOR + '">uEUF </font>' + browser + '<br>' +
                   	 '<font color="' + ITEM_COLOR + '">zXgF </font>' +
                     '<a href="' + ANALYZE_SCRIPT + '?mode=search&type=&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + 
                                                                      '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] +
                                                                      '&apage=' + apage + '&item=3&key=' + host + '">#</a>' +
                     
                     ' ' + '<a href="' + JUMP_SCRIPT + '?ip=' + host + '" target="_blank">' + host + '</a>@<font color="' + ITEM_COLOR + '">IPF </font>' + ip + '<br>' +
                   	 '<font color="' + ITEM_COLOR + '">t@[F </font><a href="' + JUMP_SCRIPT + '?url=' + CGI.escape(referer) + '" target="_blank">' + ((unescaperef.size <= 75) ? (unescaperef) : (unescaperef[0..75] + '...')) + '</a><br>' +
                   	 '<font color="' + ITEM_COLOR + '">UserAgentF </font>' + CGI.escapeHTML(useragent) + 
                     
                     '<div style="text-align: right">' +
                     
                     '<form style="margin: 2px;" action="' + ANALYZE_SCRIPT + '" method="GET">
                     <input type="hidden" name="mode" value="check">
                     <input type="hidden" name="type" value="delete_log">
                     <input type="hidden" name="apage" value="' + apage + '">
                     <input type="hidden" name="date" value="' + date + '">
                     <input type="hidden" name="uid" value="' + id + '">
                     <input type="hidden" name="pid" value="' + pid + '">
                     <input type="hidden" name="sy" value="' + sdate[0] + '">
                     <input type="hidden" name="sm" value="' + sdate[1] + '">
                     <input type="hidden" name="sd" value="' + sdate[2] + '">
                     <input type="hidden" name="ey" value="' + edate[0] + '">
                     <input type="hidden" name="em" value="' + edate[1] + '">
                     <input type="hidden" name="ed" value="' + edate[2] + '">
                     <input type="submit" value="폜" style="width:34; height:18; border-style:solid; border-width:1px; border-color:' + MENU_COLOR + '; color:' + BODY_TEXT_COLOR + '; background:' + BODY_BACK_COLOR + ';">
                     </form>' +
                     
                     '</div>' +
                     
                     '</div>' +
                     '</td>' +
            	       '</tr>' +
							 	 
                     '<tr><td colspan="2"><br></td></tr>'
    }


		mhtml = '<div class="cell_back" style="height: 100%">' +
    				'<table border="0" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
            '<tr><td colspan="2"><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>@(' + sdate[0] + 'N' + sdate[1] + '' + sdate[2] + '`' +
                                                                                                  edate[0] + 'N' + edate[1] + '' + edate[2] + ')</div></td></tr>' +
            '</tbody></table>' +
            
            '<table border="0" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
            '<tr><td colspan="2"><br></td></tr>' +
                                                                                            
            '<tr><td colspan="2"><table border="1" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
            '<tr><td align="center"><div class="cell_menu" style="text-align:center;">ڂIāAL[[h͂ĉ(͂ꍇ̓Xy[Xŋ؂)</div></td></tr>' +
            
               '<tr>
                <td>
                <div class="cell_body" style="text-align: center">
                	<table border="0" cellpadding="0" cellspacing="0" align="center">
                  <tr>
                  	<form method="get" action="' + ANALYZE_SCRIPT + '">
                    <input type="hidden" name="mode" value="search">
                    <input type="hidden" name="type" value="' + type + '">
                    <input type="hidden" name="apage" value="' + apage + '">
                    <input type="hidden" name="sy" value="' + sdate[0] + '"><input type="hidden" name="sm" value="' + sdate[1] + '"><input type="hidden" name="sd" value="' + sdate[2] + '">
                    <input type="hidden" name="ey" value="' + edate[0] + '"><input type="hidden" name="em" value="' + edate[1] + '"><input type="hidden" name="ed" value="' + edate[2] + '">
                                     
                    <td>
                  	
                    <select name="item">
                  	<option value="0" ' + ((item == '0') ? ('selected') : ('')) + '>SĂ̍</option>
                    <option value="1" ' + ((item == '1') ? ('selected') : ('')) + '></option>
                    <option value="2" ' + ((item == '2') ? ('selected') : ('')) + '>[U[ID</option>
                    <option value="3" ' + ((item == '3') ? ('selected') : ('')) + '>zXg</option>
                    <option value="4" ' + ((item == '4') ? ('selected') : ('')) + '>IP</option>
                    <option value="5" ' + ((item == '5') ? ('selected') : ('')) + '>NGXgURL</option>
                    <option value="6" ' + ((item == '6') ? ('selected') : ('')) + '>y[WID</option>
                    <option value="7" ' + ((item == '7') ? ('selected') : ('')) + '>t@[</option>
                    <option value="8" ' + ((item == '8') ? ('selected') : ('')) + '>UserAgent</option>
                    <option value="9" ' + ((item == '9') ? ('selected') : ('')) + '>ʏ</option>
                    <option value="10" ' + ((item == '10') ? ('selected') : ('')) + '>JavaScript</option>
                    <option value="11" ' + ((item == '11') ? ('selected') : ('')) + '>Cookie</option>
                    <option value="12" ' + ((item == '12') ? ('selected') : ('')) + '>OS</option>
                    <option value="13" ' + ((item == '13') ? ('selected') : ('')) + '>uEU</option>
                    <option value="14" ' + ((item == '14') ? ('selected') : ('')) + '>GW</option>
                    <option value="15" ' + ((item == '15') ? ('selected') : ('')) + '>L[[h</option>
                    </select>
                  	
                  	<input type="text" name="key" size="40" value="' + key.gsub(/"/, '&quot;') + '">
                     
                    <select name="ope">
                    <option value="AND"' + ((ope == 'AND') ? ('selected') : ('')) + '>AND</option>
                    <option value="OR"' + ((ope == 'OR') ? ('selected') : ('')) + '>OR</option>
                    </select>
                     
                    <input type="submit" value="">
                    
                  	</td>
                    
                    </form>
                  </tr>
                  </table>
                </div>
                </td>
                </tr>' +
            
            '<tr><td align="center">' + log.size.to_s + '</td></tr>'
            
    mhtml += '<tr><td align="center">'
    pages = (((log.size < 1) ? (1) : (log.size)) / SHOW_LOG_COUNT.to_f).ceil
    pages.times{|i|
    	if i != page
      	mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      					 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    	else
      	mhtml += '<b>' + (i + 1).to_s + '</b> '
      end
    }
    mhtml += '</td></tr>' +	
             '</tbody></table></td></tr>' +
             '<tr><td colspan="2"><br></td></tr>'
    
    mhtml += thtml
 		
    mhtml += '<tr><td colspan="2"><table border="1" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
    				 '<tr><td align="center">'
    pages.times{|i|
    	if i != page
      	mhtml += '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] +
      					 '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '&page=' + i.to_s + '">' + (i + 1).to_s + '</a> '
    	else
      	mhtml += '<b>' + (i + 1).to_s + '</b> '
      end
    }
    mhtml += '</td></tr>' +
             '</tbody></table></td></tr>' +
             '<tr><td colspan="2"><br></td></tr>'
   
    mhtml += '</tbody></table></div>'
  end
  
  #--- eݒ -------------------------------
  def Analyze.config(mode, type, apage, sdate, edate)
    title = (type == 'pid') ? ('y[WIDҏW') : ('ef[^ҏW')
    thtml = ''
    
    mhtml =  '<div class="cell_back" style="height: 100%">' +
    				
             '<table border="0" cellpadding="0" cellspacing="0" align="center" width="624"><tbody>' +
             '<tr><td colspan="2"><div class="cell_menu"><font color="' + WEEK_BACK_COLOR + '"></font>' + title + '</div></td></tr>' +
             '</tbody></table>' +
            
             '<table border="0" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
            
             '<tr><td colspan="2"><br></td></tr>'
    
    case type
      when 'pid'
        recpath = 'http://' + ENV['HTTP_HOST'] + ENV['SCRIPT_NAME']
        recpath = recpath.scan(/(.*\/).*$/)[0][0] + RECORD_SCRIPT
    
        PAGE_NAMES.each{|pid, url|
      
          thtml += '<tr>' +
                   '<td width="27%"><div class="cell_menu" style="text-align: left">[' + pid + ']@' + ((url.size > 70) ? (url[0..70] + '...') : (url)) + '</div></td>' +
          	       '</tr>' +
            	     '<tr>' +
            	     '<td colspan="2">' +
        			     '<div class="cell_body">' +
               
                   '<center>' +
                   '<br>' +
                   'ȉ̃R[h͑Ώۂhtmlt@C &lt;body&gt;`&lt;/body&gt; ̊Ԃɓ\tĉ' +
                   '<textarea name="acode" cols="70" rows="4" wrap="off">' + 

"<script language=\"JavaScript\">
<!--
document.cookie = 'aa_cookie_check=true;';
ck = (document.cookie.indexOf('aa_cookie_check') != -1) ? ('ON') : ('OFF');
document.cookie = 'aa_cookie_check=true;' + 'expires=Fri, 10-Dec-1999 23:59:59;';
buf = escape(parent.document.referrer);
ref = '';
for (i = 0; i < buf.length; i++) { str = buf.charAt(i); ref += (str == '+') ? '%2B' : str; }
buf = escape(location.href);
url = '';
for (i = 0; i < buf.length; i++) { str = buf.charAt(i); url += (str == '+') ? '%2B' : str; }
scr = screen.width+'x'+screen.height+'x'+screen.colorDepth;
document.write('<img src=\"" + recpath + "?pid=" + pid + "&ref=',ref,'&scr=',scr,'&url=',url,'&jvs=ON&ck=',ck,'\" border=\"0\" width=\"1\" height=\"1\" />');
// -->
</script>
<noscript>
<img src=\"" + recpath + "?pid=" + pid + "&ref=NoScript&scr=NoScript&url=NoScript&jvs=OFF&ck=--\" border=\"0\" width=\"1\" height=\"1\" />
</noscript>" +
               
                   '</textarea>' +
                   '</center>' +
               
                   '<div style="text-align: right">' +
                     
                   '<form style="margin: 2px;" action="' + ANALYZE_SCRIPT + '" method="GET">
                   <input type="hidden" name="mode" value="check">
                   <input type="hidden" name="type" value="delete_page">
                   <input type="hidden" name="apage" value="' + apage + '">
                   <input type="hidden" name="pid" value="' + pid + '">
                   <input type="hidden" name="url" value="' + url + '">
                   <input type="hidden" name="sy" value="' + sdate[0] + '">
                   <input type="hidden" name="sm" value="' + sdate[1] + '">
                   <input type="hidden" name="sd" value="' + sdate[2] + '">
                   <input type="hidden" name="ey" value="' + edate[0] + '">
                   <input type="hidden" name="em" value="' + edate[1] + '">
                   <input type="hidden" name="ed" value="' + edate[2] + '">
                   <input type="submit" value="폜" style="width:34; height:18; border-style:solid; border-width:1px; border-color:' + MENU_COLOR + '; color:' + BODY_TEXT_COLOR + '; background:' + BODY_BACK_COLOR + ';">
                   </form>' +
                     
                   '</div>' +
                     
                   '</div>' +
                   '</td>' +
                   '</tr>' +
							 	 
                   '<tr><td><br></td></tr>'
      }
    
    
      mhtml +=                                             
            '<tr><td><table border="1" cellpadding="0" cellspacing="0" align="center" width="600"><tbody>' +
            '<tr><td align="center"><div class="cell_menu" style="text-align:center;">͂y[W̏͂ĉ(y[WID & URL)</div></td></tr>' +
            
            '<tr>
             <td>
             <div class="cell_body" style="text-align: center">
             <br>
                  <table border="1" cellpadding="0" cellspacing="0" align="center">
                  <tr>
                  	<form method="get" action="' + ANALYZE_SCRIPT + '">
                    <input type="hidden" name="mode" value="check">
                    <input type="hidden" name="type" value="add_page">
                    <input type="hidden" name="apage" value="' + apage + '">
                    <input type="hidden" name="sy" value="' + sdate[0] + '"><input type="hidden" name="sm" value="' + sdate[1] + '"><input type="hidden" name="sd" value="' + sdate[2] + '">
                    <input type="hidden" name="ey" value="' + edate[0] + '"><input type="hidden" name="em" value="' + edate[1] + '"><input type="hidden" name="ed" value="' + edate[2] + '">
                    
                    <tr>
                    <td>y[WID(pp)</td>
                    <td>URL</td>
                    </tr>
                    
                    <tr>
                    <td>
                  	<input type="text" name="pid" size="22" value="">
                  	</td>
                    
                    <td>
                  	<input type="text" name="url" size="70" value="">
                  	</td>
                    </tr>
                    
                    <tr>
                    <td colspan="2" align="center">
                    <input type="submit" value="ǉ">
                  	</td>
                    </tr>
                    </form>
                  </tr>
                  </table>
             <br>
             </div>
             </td>
             </tr>
   
             </tbody></table></td></tr>
             
             <tr><td><br></td></tr>'
             
      when 'data'
      
        thtml += '<tr>' +
                 '<td width="27%"><div class="cell_menu" style="text-align: left">AvP[Vf[^(app_data' + DATA_EXT + ')</div></td>' +
          	     '</tr>' +
            	   '<tr>' +
            	   '<td colspan="2">' +
        			   '<div class="cell_body">' +
                 
                 '<br>' +
               
                 '<table border="1" cellpadding="0" cellspacing="0" align="center">
                  <tr>
                  	<form method="post" action="' + ANALYZE_SCRIPT + '">
                    <input type="hidden" name="mode" value="execute">
                    <input type="hidden" name="type" value="update_app_data">
                    <input type="hidden" name="apage" value="' + apage + '">
                    <input type="hidden" name="sy" value="' + sdate[0] + '"><input type="hidden" name="sm" value="' + sdate[1] + '"><input type="hidden" name="sd" value="' + sdate[2] + '">
                    <input type="hidden" name="ey" value="' + edate[0] + '"><input type="hidden" name="em" value="' + edate[1] + '"><input type="hidden" name="ed" value="' + edate[2] + '">
                    
                    <tr>
                    <td colspan="2" width="170">pX[h</td><td><input type="text" name="pass" size="40" value="' + PASSWORD + '"></td>
                    </tr>
                    <tr>
                    <td colspan="2">O~bg(P: )</td><td><input type="text" name="log_limit" size="40" value="' + (LOG_LIMIT / 60 / 60 / 24).to_s + '"></td>
                    </tr>
                    <tr>
                    <td colspan="2">1y[W̕\O</td><td><input type="text" name="log_count" size="40" value="' + SHOW_LOG_COUNT.to_s + '"></td>
                    </tr>
                    <tr>
                    <td colspan="2">1y[W̕\ACe</td><td><input type="text" name="item_count" size="40" value="' + SHOW_ITEM_COUNT.to_s + '"></td>
                    </tr>
                    
                    <tr>
                    <td colspan="3"><br></td>
                    </tr>
                    
                    <tr>
                    <td>^CgF</td><td width="20" bgcolor="' + TITLE_COLOR + '">@</td><td><input type="text" name="title_color" size="40" value="' + TITLE_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>wiF</td><td bgcolor="' + BACK_COLOR + '">@</td><td><input type="text" name="back_color" size="40" value="' + BACK_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>j[F</td><td bgcolor="' + MENU_COLOR + '">@</td><td><input type="text" name="menu_color" size="40" value="' + MENU_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>BodyF</td><td bgcolor="' + BODY_COLOR + '">@</td><td><input type="text" name="body_color" size="40" value="' + BODY_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>BodyBackF</td><td bgcolor="' + BODY_BACK_COLOR + '">@</td><td><input type="text" name="bback_color" size="40" value="' + BODY_BACK_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>WeekBackF</td><td bgcolor="' + WEEK_BACK_COLOR + '">@</td><td><input type="text" name="week_color" size="40" value="' + WEEK_BACK_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>GraphBackF</td><td bgcolor="' + GRAPH_BACK_COLOR + '">@</td><td><input type="text" name="graph_color" size="40" value="' + GRAPH_BACK_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>CellBackF</td><td bgcolor="' + CELL_BACK_COLOR + '">@</td><td><input type="text" name="cell_color" size="40" value="' + CELL_BACK_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>eLXgF</td><td bgcolor="' + BODY_TEXT_COLOR + '">@</td><td><input type="text" name="body_text" size="40" value="' + BODY_TEXT_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>j[eLXgF</td><td bgcolor="' + MENU_TEXT_COLOR + '">@</td><td><input type="text" name="menu_text" size="40" value="' + MENU_TEXT_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>^CgeLXgF</td><td bgcolor="' + TITLE_TEXT_COLOR + '">@</td><td><input type="text" name="title_text" size="40" value="' + TITLE_TEXT_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>NF</td><td bgcolor="' + LINK_COLOR + '">@</td><td><input type="text" name="link_color" size="40" value="' + LINK_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>HNF</td><td bgcolor="' + HLINK_COLOR + '">@</td><td><input type="text" name="hlink_color" size="40" value="' + HLINK_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>ڐF</td><td bgcolor="' + ITEM_COLOR + '">@</td><td><input type="text" name="item_color" size="40" value="' + ITEM_COLOR + '"></td>
                    </tr>
                    <tr>
                    <td>OtF</td>
                    <td colspan="2">
                    <select name="graph_num">
                    <option value="1" ' + ((GRAPH_COLOR_NUM == '1') ? ('selected') : ('')) + '>O[</option>
                    <option value="2" ' + ((GRAPH_COLOR_NUM == '2') ? ('selected') : ('')) + ' ></option>
                    <option value="3" ' + ((GRAPH_COLOR_NUM == '3') ? ('selected') : ('')) + ' ></option>
                    <option value="4" ' + ((GRAPH_COLOR_NUM == '4') ? ('selected') : ('')) + ' ></option>
                    <option value="5" ' + ((GRAPH_COLOR_NUM == '5') ? ('selected') : ('')) + ' ></option>
                    <option value="6" ' + ((GRAPH_COLOR_NUM == '6') ? ('selected') : ('')) + ' ></option>
                    </td>
                    </tr>

                    
                    <tr>
                    <td colspan="3" align="center">
                    <input type="submit" value="XV">
                  	</td>
                    </tr>
                    </form>
                  </tr>
                  </table>' +
                  
                 '<br>' +
                 
                 '</div>' +
                 '</td>' +
                 '</tr>' +
                 
                 
                 '<tr><td><br></td></tr>' +
                 
                 
                 '<tr>' +
                 '<td width="27%"><div class="cell_menu" style="text-align: left">uEUf[^(browser_names' + DATA_EXT + ')</div></td>' +
          	     '</tr>' +
            	   '<tr>' +
            	   '<td colspan="2">' +
        			   '<div class="cell_body">' +
                 
                 '<br>' +
               
                 '<table border="1" cellpadding="0" cellspacing="0" align="center">
                  <tr>
                  	<form method="post" action="' + ANALYZE_SCRIPT + '">
                    <input type="hidden" name="mode" value="execute">
                    <input type="hidden" name="type" value="update_browser_names">
                    <input type="hidden" name="apage" value="' + apage + '">
                    <input type="hidden" name="sy" value="' + sdate[0] + '"><input type="hidden" name="sm" value="' + sdate[1] + '"><input type="hidden" name="sd" value="' + sdate[2] + '">
                    <input type="hidden" name="ey" value="' + edate[0] + '"><input type="hidden" name="em" value="' + edate[1] + '"><input type="hidden" name="ed" value="' + edate[2] + '">
                    
                    <tr>
                    <td>[ʕ],[uEU(\p)]</td>
                    </tr>
                    
                    <tr>
                    <td>
                    <textarea name="data" cols="70" rows="8" wrap="off">' + self.safe_read(DATA_DIR + '/' + 'browser_names' + DATA_EXT) + '</textarea>
                    </td>
                    </tr>
                    
                    <tr>
                    <td colspan="3" align="center">
                    <input type="submit" value="XV">
                  	</td>
                    </tr>
                    </form>
                  </tr>
                  </table>' +
                  
                 '<br>' +
                 
                 '</div>' +
                 '</td>' +
                 '</tr>' +
                 
                 
                 '<tr><td><br></td></tr>' +
                 
                 
                 '<tr>' +
                 '<td width="27%"><div class="cell_menu" style="text-align: left">OSf[^(os_names' + DATA_EXT + ')</div></td>' +
          	     '</tr>' +
            	   '<tr>' +
            	   '<td colspan="2">' +
        			   '<div class="cell_body">' +
                 
                 '<br>' +
               
                 '<table border="1" cellpadding="0" cellspacing="0" align="center">
                  <tr>
                  	<form method="post" action="' + ANALYZE_SCRIPT + '">
                    <input type="hidden" name="mode" value="execute">
                    <input type="hidden" name="type" value="update_os_names">
                    <input type="hidden" name="apage" value="' + apage + '">
                    <input type="hidden" name="sy" value="' + sdate[0] + '"><input type="hidden" name="sm" value="' + sdate[1] + '"><input type="hidden" name="sd" value="' + sdate[2] + '">
                    <input type="hidden" name="ey" value="' + edate[0] + '"><input type="hidden" name="em" value="' + edate[1] + '"><input type="hidden" name="ed" value="' + edate[2] + '">
                    
                    <tr>
                    <td>[ʕ],[OS(\p)]</td>
                    </tr>
                    
                    <tr>
                    <td>
                    <textarea name="data" cols="70" rows="8" wrap="off">' + self.safe_read(DATA_DIR + '/' + 'os_names' + DATA_EXT) + '</textarea>
                    </td>
                    </tr>
                    
                    <tr>
                    <td colspan="3" align="center">
                    <input type="submit" value="XV">
                  	</td>
                    </tr>
                    </form>
                  </tr>
                  </table>' +
                  
                 '<br>' +
                 
                 '</div>' +
                 '</td>' +
                 '</tr>' +
                 
                 
                 '<tr><td><br></td></tr>' +
                 
                 
                 '<tr>' +
                 '<td width="27%"><div class="cell_menu" style="text-align: left">GWf[^(searchengin_names' + DATA_EXT + ')</div></td>' +
          	     '</tr>' +
            	   '<tr>' +
            	   '<td colspan="2">' +
        			   '<div class="cell_body">' +
                 
                 '<br>' +
               
                 '<table border="1" cellpadding="0" cellspacing="0" align="center">
                  <tr>
                  	<form method="post" action="' + ANALYZE_SCRIPT + '">
                    <input type="hidden" name="mode" value="execute">
                    <input type="hidden" name="type" value="update_searchengin_names">
                    <input type="hidden" name="apage" value="' + apage + '">
                    <input type="hidden" name="sy" value="' + sdate[0] + '"><input type="hidden" name="sm" value="' + sdate[1] + '"><input type="hidden" name="sd" value="' + sdate[2] + '">
                    <input type="hidden" name="ey" value="' + edate[0] + '"><input type="hidden" name="em" value="' + edate[1] + '"><input type="hidden" name="ed" value="' + edate[2] + '">
                    
                    <tr>
                    <td>[T[`GW(\p)],[ʕ(w̏ꍇu|vŋ؂)],[NG]</td>
                    </tr>
                    
                    <tr>
                    <td>
                    <textarea name="data" cols="70" rows="8" wrap="off">' + self.safe_read(DATA_DIR + '/' + 'searchengin_names' + DATA_EXT) + '</textarea>
                    </td>
                    </tr>
                    
                    <tr>
                    <td colspan="3" align="center">
                    <input type="submit" value="XV">
                  	</td>
                    </tr>
                    </form>
                  </tr>
                  </table>' +
                  
                 '<br>' +
                 
                 '</div>' +
                 '</td>' +
                 '</tr>' +
                 
                 
                 '<tr><td><br></td></tr>' +
                 
                 
                 '<tr>' +
                 '<td width="27%"><div class="cell_menu" style="text-align: left">L^OIDf[^(except_id' + DATA_EXT + ')</div></td>' +
          	     '</tr>' +
            	   '<tr>' +
            	   '<td colspan="2">' +
        			   '<div class="cell_body">' +
                 
                 '<br>' +
               
                 '<table border="1" cellpadding="0" cellspacing="0" align="center">
                  <tr>
                  	<form method="post" action="' + ANALYZE_SCRIPT + '">
                    <input type="hidden" name="mode" value="execute">
                    <input type="hidden" name="type" value="update_except_id">
                    <input type="hidden" name="apage" value="' + apage + '">
                    <input type="hidden" name="sy" value="' + sdate[0] + '"><input type="hidden" name="sm" value="' + sdate[1] + '"><input type="hidden" name="sd" value="' + sdate[2] + '">
                    <input type="hidden" name="ey" value="' + edate[0] + '"><input type="hidden" name="em" value="' + edate[1] + '"><input type="hidden" name="ed" value="' + edate[2] + '">
                    
                    <tr>
                    <td>[IDԍ]</td>
                    </tr>
                    
                    <tr>
                    <td>
                    <textarea name="data" cols="70" rows="8" wrap="off">' + self.safe_read(DATA_DIR + '/' + 'except_id' + DATA_EXT) + '</textarea>
                    </td>
                    </tr>
                    
                    <tr>
                    <td colspan="3" align="center">
                    <input type="submit" value="XV">
                  	</td>
                    </tr>
                    </form>
                  </tr>
                  </table>' +
                  
                 '<br>' +
                 
                 '</div>' +
                 '</td>' +
                 '</tr>' +
                 
                 '<tr><td><br></td></tr>'
        
    end
    
    
    mhtml += thtml +
    
             '</tbody></table></div>'
  end
  
  #--- Cʕ` -------------------------
  def Analyze.draw(mode, type, mhtml, apage, sdate, edate, item = '', key = '', ope = '')
  	if apage == ''
    	apage = 'all'
    end
    
    today = Time.now.strftime("%Y %m %d").split(' ')
    sdate = [((sdate[0] == '') ? (today[0]) : (sdate[0])), ((sdate[1] == '') ? (today[1]) : (sdate[1])), ((sdate[2] == '') ? (today[2]) : (sdate[2]))]
  	edate = [((edate[0] == '') ? (today[0]) : (edate[0])), ((edate[1] == '') ? (today[1]) : (edate[1])), ((edate[2] == '') ? (today[2]) : (edate[2]))]
  	
  	yesday = self.adjust_date(today, -1)
    oneweek = self.adjust_date(today, -7)
    onemonth = self.adjust_date(today, -30)
    
    adsense = self.safe_read(DATA_DIR + '/adsense' + DATA_EXT)
    
  	html = self.header +
            '<center>' + adsense + '</center>' +
  	
    				'<table border="1" cellpadding="0" cellspacing="0" align="center" width="800"><tbody>' +
            
            '<tr>' +
            '<td colspan="2">' + ANALYZER_TITLE_HTML + '</td>' +
    				'</tr>' +
            
            '<tr>' +
            
            '<td valign="top" width="156" height="100%">' +
            '<table border="0" cellpadding="0" cellspacing="0" align="left" height="100%"><tbody>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>͑Ώ</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td>' +
            '<div class="cell_body">' +
            '<center>' +
            
            self.calendar(mode, type, apage, sdate, edate, item, key, ope) +
            
            '<form action="' + ANALYZE_SCRIPT + '" method="GET">' +
            
            '<input type="hidden" name="mode" value="' + mode + '">' +
            '<input type="hidden" name="type" value="' + type + '">' +
            '<input type="hidden" name="item" value="' + item + '">' +
            '<input type="hidden" name="key" value="' + key + '">' +
            '<input type="hidden" name="ope" value="' + ope + '">' +
            
            'Jn<br>' +
            '<select name="sy">'
            Log.get_valid_years(apage).each{|v|
            	html += '<option value="' + v + '" ' + ((v == sdate[0]) ? ('selected') : ('')) + '>' + v + '</option>'
            }
            html += '</select>' +
            
            '<select name="sm">'
            (1..12).each{|i|
            	html += '<option value="' + sprintf("%02d", i) + '" ' + ((i == sdate[1].to_i) ? ('selected') : ('')) + '>' + sprintf("%02d", i) + '</option>'
            }
            html += '</select>' +
            
            '<select name="sd">'
            (1..31).each{|i|
 							html += '<option value="' + sprintf("%02d", i) + '" ' + ((i == sdate[2].to_i) ? ('selected') : ('')) + '>' + sprintf("%02d", i) + '</option>'
            }
            html += '</select>' +
            
            '<br>' +
            
            'I<br>' +
            '<select name="ey">'
            Log.get_valid_years(apage).each{|v|
            	html += '<option value="' + v + '" ' + ((v == edate[0]) ? ('selected') : ('')) + '>' + v + '</option>'
            }
            html += '</select>' +
            
            '<select name="em">'
            (1..12).each{|i|
            	html += '<option value="' + sprintf("%02d", i) + '" ' + ((i == edate[1].to_i) ? ('selected') : ('')) + '>' + sprintf("%02d", i) +  '</option>'
            }
            html += '</select>' +
            
            '<select name="ed">'
            (1..31).each{|i|
            	html += '<option value="' + sprintf("%02d", i) + '" ' + ((i == edate[2].to_i) ? ('selected') : ('')) + '>' + sprintf("%02d", i) + '</option>'
            }
            html += '</select>' +

            '<br><br>' +
            
            
            '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + onemonth[0] + '&sm=' + onemonth[1] + '&sd=' + onemonth[2] + '&ey=' + today[0] + '&em=' + today[1] + '&ed=' + today[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '">1</a>/' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + oneweek[0] + '&sm=' + oneweek[1] + '&sd=' + oneweek[2] + '&ey=' + today[0] + '&em=' + today[1] + '&ed=' + today[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '">1T</a>/' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + yesday[0] + '&sm=' + yesday[1] + '&sd=' + yesday[2] + '&ey=' + yesday[0] + '&em=' + yesday[1] + '&ed=' + yesday[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '"></a>/' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=' + mode + '&type=' + type + '&sy=' + today[0] + '&sm=' + today[1] + '&sd=' + today[2] + '&ey=' + today[0] + '&em=' + today[1] + '&ed=' + today[2] + '&apage=' + apage + '&item=' + item + '&key=' + CGI.escape(key) + '&ope=' + ope + '"></a>' +
            
            '<br><br>' +
            
            '̓y[WF<br><select name="apage">' +
            '<option value="all">Sy[W</option>'
            PAGE_NAMES.keys.sort.each{|v|
            	html += '<option value="' + v + '"' + ((apage == v) ? (' selected') : ('')) + '>' + v + '</option>'
            }
            html += '</select>' +
            
            '<br>' +
            
            '<br><input type="submit" value="Analyze">' +
            '</form>' +
            '</center>' +
            '</div>' +
            '</td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">@<a href="' + ANALYZE_SCRIPT + '?mode=explain' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">gbvy[W</a></div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>ANZXO</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">@O: ' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=log&type=simple' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">Ȉ</a>/' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=log&type=detail' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">ڍ</a><br>' +
            '@_E[h</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>ANZXv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">' +
            '@V: ' +
              '<a href="' + ANALYZE_SCRIPT + '?mode=count_v&type=time' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">ԕ</a>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=count_v&type=day' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '"></a>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=count_v&type=month' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '"></a><br>' +
            '@H: ' +
              '<a href="' + ANALYZE_SCRIPT + '?mode=count_h&type=time' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">ԕ</a>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=count_h&type=day' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '"></a>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=count_h&type=month' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '"></a><br>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>Nv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=link&type=url' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">NURL</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=link&type=domain' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">NhC</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=link&type=engin' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">GW</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=link&type=keyword' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">L[[h</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=link&type=phrase' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">t[Y</a>' +
            '</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>VXev</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">' +
            '@uEU: ' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=system&type=browser_simple' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">Ȉ</a>' +
            '/' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=system&type=browser_detail' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">ڍ</a><br>' +
            '@OS: ' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=system&type=os_simple' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">Ȉ</a>' +
            '/' +
            '<a href="' + ANALYZE_SCRIPT + '?mode=system&type=os_detail' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">ڍ</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=system&type=screen' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '"></a>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=system&type=js' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">JavaScript</a>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=system&type=cookie' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">Cookie</a>' +
            '</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>Kғv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=visitor&type=uid' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">[U[ID</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=visitor&type=host' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">zXg</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=visitor&type=vcount' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">K</a>' +
            '</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>TCgv</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=site&type=popular' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">lCy[W</a><br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=site&type=pid' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">y[WID</a>' +
            '</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font></div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=search&type=' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">O</a>' +
            '</div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td><div class="cell_menu" style="width: 156;"><font color="' + WEEK_BACK_COLOR + '"></font>eݒ</div></td>' +
            '</tr>' +
            '<tr>' +
            '<td><div class="cell_body">' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=config&type=pid' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">y[WIDҏW</a>' +
            '<br>' +
            '@<a href="' + ANALYZE_SCRIPT + '?mode=config&type=data' + '&sy=' + sdate[0] + '&sm=' + sdate[1] + '&sd=' + sdate[2] + '&ey=' + edate[0] + '&em=' + edate[1] + '&ed=' + edate[2] + '&apage=' + apage + '">ef[^ҏW</a>' +
            '<br>' + 
            '<hr size="1"></div></td>' +
            '</tr>' +
            
            '<tr>' +
            '<td width="100%" height="100%" bgcolor="' + BODY_COLOR + '" valign="top"></td>' +
            '</tr>' +
            
            '</tbody></table>' +
            '</td>' +
						

            
            
            '<td valign="top">' +
            mhtml +
            '</td>' +
            
            '</tr>' +
            
            '</tbody></table>' +
            
            '<hr size="1">' +
            
            COPYRIGHT_HTML
    
    
  	html += self.footer
    
    Cgi.out{ html }
  end
  
  
public
  #--- \ -----------------------------------
  def Analyze.show(mode)
  	
    if Cgi.cookies['session_pass'][0].to_s != PASSWORD
    	mode = ((mode != 'login') ? ('') : (mode))
    end
    
    mhtml = ''
    
  	case mode
      when 'check'
        mhtml = self.check(Cgi['type'], Cgi['apage'], Cgi['date'], Cgi['uid'], Cgi['pid'], Cgi['url'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])

      when 'execute'
        case Cgi['type']
          when 'delete_log'
            self.delete_log(Cgi['apage'], Cgi['date'], Cgi['uid'], Cgi['pid'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
          when 'delete_page'
            self.delete_page(Cgi['apage'], Cgi['pid'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
          when 'add_page'
            self.add_page(Cgi['apage'], Cgi['pid'], Cgi['url'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
          when 'update_app_data'
            self.update_app_data(Cgi['apage'], [Cgi['pass'], Cgi['log_limit'], Cgi['log_count'], Cgi['item_count'],
                                                Cgi['title_color'], Cgi['back_color'], Cgi['menu_color'], Cgi['body_color'],
                                                Cgi['bback_color'], Cgi['week_color'], Cgi['graph_color'], Cgi['cell_color'],
                                                Cgi['body_text'], Cgi['menu_text'], Cgi['title_text'], Cgi['link_color'],
                                                Cgi['hlink_color'], Cgi['item_color'], Cgi['graph_num']], 
                                 [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
          when 'update_browser_names'
            self.update_browser_names(Cgi['apage'], Cgi['data'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
          when 'update_os_names'
            self.update_os_names(Cgi['apage'], Cgi['data'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
          when 'update_searchengin_names'
            self.update_searchengin_names(Cgi['apage'], Cgi['data'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
          when 'update_except_id'
            self.update_except_id(Cgi['apage'], Cgi['data'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
        end

      when 'explain'
      	mhtml = self.explain
      	self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'log'
      	mhtml = self.log(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']], Cgi['page'])
      	self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'count_v', 'count_h'
      	mhtml = self.count(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'link'
      	mhtml = self.link(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']], Cgi['page'])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'system'
      	mhtml = self.system(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']], Cgi['page'])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'visitor'
      	mhtml = self.visitor(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']], Cgi['page'])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'site'
      	mhtml = self.site(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']], Cgi['page'])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'search'
        mhtml = self.search(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']], Cgi['item'], Cgi['key'], Cgi['ope'], Cgi['page'])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']], Cgi['item'], Cgi['key'], Cgi['ope'])
      when 'config'
      	mhtml = self.config(mode, Cgi['type'], Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
        self.draw(mode, Cgi['type'], mhtml, Cgi['apage'], [Cgi['sy'], Cgi['sm'], Cgi['sd']], [Cgi['ey'], Cgi['em'], Cgi['ed']])
      when 'login'
      	self.login(Cgi['password'])
      else
      	self.show_login
    end
  end
  
	#def initialize
	#end
    
end


	Analyze.show(Cgi['mode'])
  

rescue

error_cgi

end



