#--------------------------------------------------------
# Ruby for ACS Analyzer             ver1.01  RR 2007-2009
# log
#
# url   : http://www.runread.com/
# e-mail: info@runread.com
#--------------------------------------------------------
STDOUT.sync=true

require 'settings.rb'
require 'common.rb'
#require "shellwords"



class Log

extend Common
include Common

protected
  #--- ^[QbgO擾 ---------------------
  def get_target
    ap = [@page]
  	if @page == 'all'
    	ap = PAGE_NAMES.keys
    end
    
    @logs = []
    ap.each{|v|
    	if @sdate[0] < @edate[0]
    		(@sdate[0]..@edate[0]).each{|y|
          sm = ((y == @sdate[0]) ? (@sdate[1]) : ('01'))
          em = ((y == @edate[0]) ? (@edate[1]) : ('12'))
          (sm..em).each{|m|
      			fn = LOG_DIR + '/' + v + '/' + y + '_' + m + LOG_EXT
          	if File.exist?(fn)
          		@logs += self.safe_read(fn).split("\n")
          	end
      		}
      	}
      else
      	(@sdate[0]..@edate[0]).each{|y|
        	(@sdate[1]..@edate[1]).each{|m|
      			fn = LOG_DIR + '/' + v + '/' + y + '_' + m + LOG_EXT
          	if File.exist?(fn)
          		@logs += self.safe_read(fn).split("\n")
          	end
      		}
      	}
      end
    }
    
    @logs.sort!{|a, b| b <=> a }
                                                #ȉAwO̓t̃O𒲐
    
                                                #t
    cmpdate = @sdate[0] + '-' + @sdate[1] + '-' + @sdate[2]
    cnt = 0
    @logs.reverse_each{|v|
      if cmpdate > v.split('<>')[0].split(' ')[0]
        cnt += 1
      else
        break
      end
    }
    @logs.slice!(@logs.size - cnt, cnt)
                                                #t傫
    cmpdate = @edate[0] + '-' + @edate[1] + '-' + @edate[2]
    cnt = 0
    @logs.each{|v|
      if cmpdate < v.split('<>')[0].split(' ')[0]
        cnt += 1
      else
        break
      end
    }
    @logs.slice!(0, cnt)
  end
  
public
  #--- Ot@C̗L擾 -----------
  def Log.get_valid_years(apage)
  	vyears = []
    PAGE_NAMES.each_key{|k|
      if apage == k || apage == 'all'
    		dir = LOG_DIR + '/' + k + '/'
      	Dir.foreach(dir){|f|
      		if File.file?(dir + f)
    				vyears.push(f[/^[0-9]+/])
    			end
      	}
      end
    }
    
    vyears.uniq!				#vf̏ꍇnilԂ̂ŁAuniq!sort!͕ċLq
    vyears.sort!{|a, b| b <=> a}
  end
  
  #--- ~bg𒴂Of[^폜 ---------
  def Log.delete_limit
  	nowtime = Time.now.to_i
    
    years = Log.get_valid_years('all')
    if years.size == 0 then return; end
    
    
    minmon = 12                             #ŏ̃ŐL^𒼐ڃO擾
    mindate = '9999-12-31 23:59:59'
    PAGE_NAMES.each_key{|k|
      dir = LOG_DIR + '/' + k + '/'
      (1..12).each{|i|
        logname = sprintf("%s_%02d", years.reverse[0], i) + LOG_EXT
        if minmon < i
          break
        elsif File.exist?(dir + logname)
          minmon = i
          File.open(dir + logname, 'r'){|f|
            f.flock(File::LOCK_SH)
            date = f.readline.split('<>')[0]
            if mindate > date
              mindate = date
            end
            #f.flock(File::LOCK_UN)
          }
          break
        end
      }
    }
                                            #ۑ~bgzĂȂ`FbN
    (y, m, d) = mindate.split(' ')[0].split('-')
    (h, mt, s) = mindate.split(' ')[1].split(':')
    if nowtime - Time.local(y, m, d, h, mt, s).to_i <= LOG_LIMIT
      return false
    end
    
    
    
    #ȉAۑ~bgzĂꍇ̏WbN
    
    
  	                                        #ȉA̓O̍폜
    PAGE_NAMES.each_key{|k|
  		eflag = false
    	years.sort.each{|y|
    		('01'..'12').each{|m|
      		fn = LOG_DIR + '/' + k + '/' + y + '_' + m + LOG_EXT
          if File.exist?(fn)
          	logs = self.safe_read(fn).split("\n").sort{|a, b| b <=> a }
            dellogs = []
            logs.each{|v|
            	(date,) = v.split('<>')
            	(y, m, d) = date.split(' ')[0].split('-')
              (h, mt, s) = date.split(' ')[1].split(':')
            	if nowtime - Time.local(y, m, d, h, mt, s).to_i <= LOG_LIMIT
              	dellogs.push(v)
              else
                break
              end
            }
            
            if dellogs.size <= 0
            	File.delete(fn)
            else
            	dellogs.sort!
              self.safe_write(fn, 'w', dellogs.join("\n") + "\n")
              eflag = true
              break
            end
          end
      	}
        if eflag then break; end
      }
    }
    
    true
  end
  
  #--- f[^ǉ -----------------------------
  def Log.add(pid, data)
    path = LOG_DIR + '/' + pid + '/' + Time.now.strftime("%Y_%m" + LOG_EXT)
  	self.safe_write(path, 'a', data + "\n")
  end
  
  #--- f[^폜 -----------------------------
  def Log.delete(date, uid, pid)
    dt = date.split(' ')[0].split('-')
    ds = dt.clone; de = dt.clone
    ds[2] = '01'; de[2] = '31'
    
    dellog = []
    Log.new(ds, de, pid).each{|v|
      (d, i) = v.split('<>')
      if d != date || i != uid
        dellog.push(v)
      end
    }
    
    path = LOG_DIR + '/' + pid + '/' + ds[0] + '_' + ds[1] + LOG_EXT
    
    if dellog.size != 0
      self.safe_write(path, 'w', dellog.sort.join("\n") + "\n")
    else
      File.delete(path)
    end
  end
  
  #--- w胍O擾 ---------------------------
  def Log.get_appoint(date, uid, pid)
    dt = date.split(' ')[0].split('-')
    log = ''
    Log.new(dt, dt, pid).each{|v|
      (d, i) = v.split('<>')
      if d == date && i == uid
        log = v
        break
      end
    }
    log
  end

  #--- f[^ -----------------------------
  def search(item, key, ope)
    if key == '' then return []; end
    if ope == '' then ope = 'AND'; end
    
    if item == '0'
      item = 0..15                                 #ڐC̕Kv̂Œ
    else
      item = item.to_i - 1..item.to_i - 1
    end
    
    hitlogs = []
    
    key = key.scan(/"([^"]*)"|[\s@]*([^"\s@]+)[\s@]*/).map{|v| v = v.to_s }.clone
    key.delete('')
    
    hitflag = {}
    hdef = {}
    key.each{|k| hdef[k.upcase] = false }
    
    @logs.each{|log|
      sl = log.split('<>')
      
      sl[14] = CGI.unescape(sl[14].to_s).tosjis    #L[[hURLGR[h
      
      hitflag.replace(hdef)
      
      catch(:breaks){
        item.each{|i|
          key.each{|k|
            if sl[i].to_s.upcase[k.upcase]
              hitflag[k.upcase] = true
              throw :breaks if ope == 'OR'
            end
          }
        }
      }

      if (ope == 'AND' && !hitflag.value?(false)) || (ope == 'OR' && hitflag.value?(true))
        hitlogs.push(log);
      end
    }
    
    hitlogs
  end
  
  #--- each -----------------------------------
  def each
    @logs.each{|log| yield(log) }
  end
  
  #--- size -----------------------------------
  def size
    @logs.size
  end
  
  #--- [] -------------------------------------
  def [](n)
    @logs[n]
  end
  
  #---  ---------------------------------
	def initialize(sdate = nil, edate = nil, page = 'all')
    @sdate = sdate
    @edate = edate
    @page = page
    @logs = []
    
    if @sdate == nil && @edate = nil
      years = Log.get_valid_years('all')
      @sdate = []
      @edate = []
      @sdate[0] = years[0]
      @sdate[1] = '01'
      @edate[0] = years[years.size - 1]
      @edate[1] = '12'
    end
    
    self.get_target
	end
  
  
end

	







