#!/usr/local/bin/ruby -Ks

#--------------------------------------------------------
# Ruby for ACS Analyzer             ver1.01  RR 2007-2009
# record
#
# url   : http://www.runread.com/
# e-mail: info@runread.com
#--------------------------------------------------------
STDOUT.sync=true

require 'settings.rb'
require 'common.rb'
require 'log.rb'
require 'user.rb'
require 'socket'
require 'kconv'
require 'digest/md5'


begin

Cgi = CGI.new


class Record

extend Common

protected
	#--- NbL[擾 ---------------------------
  def Record.get_cookie
  	cookie = {}
    cookie['aa_no'] = ((Cgi.cookies['aa_no'][0]) ? (Cgi.cookies['aa_no'][0].to_i) : (-1))
		cookie['aa_userid'] = Cgi.cookies['aa_userid'][0] || ''
    cookie['aa_viewcount'] = Cgi.cookies['aa_viewcount'][0].to_i
  	cookie
  end
  
  #--- OS擾 -----------------------------
  def Record.get_os_info(useragent)
  	osinfo = ''
  	
    OS_NAMES.each{|v|				#Xgɂ̂ɍv
    	if useragent[v[0]]
    		osinfo = v[0] + '|' + v[1]
        break
      end
    }
    
    if osinfo == ''					#XgɂȂꍇ
    	osinfo = 'Unknown'
    end
    
  	osinfo
  end
  
  #--- uEU擾 -----------------------
  def Record.get_browser_info(useragent)
  	bsinfo = ''
 	
    BROWSER_NAMES.each{|v|
    	if useragent[v[0]]				#Xgɂ̂ɍv
      	if v[0] != 'MSIE'				#IEłȂ
        	bsinfo = useragent[/#{v[0]}\/[\w\.]+/].to_s
          break
        else										#IȄꍇ
        	bsinfo = useragent[/#{v[0]} [\w\.]+/].to_s
        	break
        end
      end
    }
    
    if bsinfo == ''							#XgɂȂꍇUser-Agent̐擪擾Ƃ
    	useragent[/(^[\w\.\/\-]+) /]
      bsinfo = (($1.to_s != '') ? ($1) : ('Unknown'))
    end

    bsinfo
  end
  
  #--- GW擾 -------------------
  def Record.get_searchengin_info(referer)
    seinfo = ''
    
    SEARCHENGIN_NAMES.each{|k, v|
    	v[0].split('|').each{|m|
      	if referer[m]
          return k
      	end
      }
    }
    
    seinfo
  end
  
  #--- L[[h擾 -----------------
  def Record.get_searchkeyword_info(engin, referer)
  	if engin == ''
    	return ''
    end
    ps = SEARCHENGIN_NAMES[engin][1]
    referer[/\W+#{ps}\=([\w\+\$\;\?\.%,!#~\*\/:@=_-]+)&*/]
    $1
    #CGI.unescape($1).tosjis					#Shift JISɕϊ
  end
  
  #--- Ȍ -------------------------
  def Record.write_log(pid, cookie, log)
    (cookie['aa_no'], cookie['aa_userid']) = User.write(cookie['aa_no'].to_i,
                                                        cookie['aa_userid'],
                                                        cookie['aa_viewcount'].to_i,
                                                        log[0] + log[3] + log[7])
    log[1] = cookie['aa_userid']
    
    Log.add(pid, log.join('<>'))
    
    cookie['aa_no']
  end

public
  #--- ANZX擾 -----------------------
  def Record.get_access_info(pid, ref, scr, url, jvs, ck)
  
    if PAGE_NAMES[pid] == nil then return; end

		if scr.to_s == '' then scr = '--'; end
    if url.to_s == '' then url = '--'; end
    if !jvs.to_s.match(/ON|OFF/) then jvs = '--'; end
    if !ck.to_s.match(/ON|OFF/) then ck = '--'; end 
    
    cookie = self.get_cookie

    date = Time.now.strftime("%Y-%m-%d %H:%M:%S")			#tԏ
    ip = ENV['REMOTE_ADDR'].to_s											#IP
    referer = ref[0].to_s 														#t@[
    useragent = ENV['HTTP_USER_AGENT'].to_s						#[U[G[WFg
   
    #url = 'http://' + ENV['HTTP_HOST'] + ENV['REQUEST_URI'] #NGXgURL
    
    cookie['aa_viewcount'] += 1												#{
    alyzpage = url.to_s 															#̓y[WURL
    screen = scr.to_s																	#XN[
   	js = jvs.to_s																			#JavaScript ON/OFF
    ck = ck.to_s                                      #Cookie ON/OFF
    os = self.get_os_info(useragent)									#OS
    browser = self.get_browser_info(useragent)				#uEU
    srchengin = self.get_searchengin_info(referer)		#T[`GW
    keyword = self.get_searchkeyword_info(srchengin, referer)	#T[`L[[h
    reserved = ''																			#\񍀖
    
    begin																			    				#ϐzXg擾
  		host = Socket.gethostbyname(ip)[0]									#Ԃ͔̂zȂ̂Yꂸ
 		rescue
  		host = ip
 		end

    log = [date, cookie['aa_userid'].to_s, host, ip, alyzpage, pid, referer, useragent,
    			 screen, js, ck, os, browser, srchengin, keyword, reserved]
  																												#OIDłȂ΃O
  	if !EXCEPT_ID.include?(cookie['aa_userid'].to_s)
      cookie['aa_no'] = self.write_log(pid, cookie, log)	#Ȍ
    end

		cookie0 = CGI::Cookie::new({'name' => 'aa_no', 'value' => cookie['aa_no'].to_s, 'expires' => Time.now + COOKIE_TIME})
		cookie1 = CGI::Cookie::new({'name' => 'aa_userid', 'value' => cookie['aa_userid'].to_s, 'expires' => Time.now + COOKIE_TIME})
    cookie2 = CGI::Cookie::new({'name' => 'aa_viewcount', 'value' => cookie['aa_viewcount'].to_s, 'expires' => Time.now + COOKIE_TIME})
    
    Cgi.out("cookie" => [cookie0, cookie1, cookie2]){''}	#NbL[𔭍s
    
  end
  
	#def initialize
	#end
    
end

	
	Record.get_access_info(Cgi['pid'], Cgi['ref'], Cgi['scr'], Cgi['url'], Cgi['jvs'], Cgi['ck'])


rescue

error_cgi

end



