#--------------------------------------------------------
# Ruby for ACS Analyzer             ver1.10c RR 2007-2009
# settings
#
# url   : http://www.runread.com/
# e-mail: info@runread.com
#--------------------------------------------------------
require 'cgi'
require 'common.rb'

RECORD_SCRIPT   = 'record.cgi'
ANALYZE_SCRIPT  = 'analyze.cgi'
JUMP_SCRIPT     = 'jump.cgi'

LOG_DIR        = 'log'                      #OfBNg
LOG_EXT        = '.txt'										  #Ot@C̊gq
DATA_DIR       = 'data'											#f[^fBNg
DATA_EXT       = '.txt'											#f[^t@Cgq
USER_EXT       = '.dat'                     #[U[t@Cgq



VERSION        = '1.10c'										#o[W


def error_cgi
print "Content-Type:text/html\n\n"
print "

*** CGI Error List ***
\n"
print "

#{CGI.escapeHTML($!.inspect)}
\n"
$@.each {|x| print CGI.escapeHTML(x), "
\n"}
end

include Common

def get_os_names
	names = []
  Common.safe_read(DATA_DIR + '/os_names' + DATA_EXT).split("\n").each{|v|
  	names.push(v.split(','))
  }
  names
end

def get_browser_names
	names = []
  Common.safe_read(DATA_DIR + '/browser_names' + DATA_EXT).split("\n").each{|v|
  	names.push(v.split(','))
  }
  names
end

def get_searchengin_names
	names = {}
  Common.safe_read(DATA_DIR + '/searchengin_names' + DATA_EXT).split("\n").each{|v|
  	a = v.split(',')
    names[a[0]] = [a[1], a[2]]
  }
  names
end

def get_page_names
	names = {}
  Common.safe_read(DATA_DIR + '/page_names' + DATA_EXT).split("\n").each{|v|
  	a = v.split(',')
    names[a[0]] = a[1]
  }
  names
end

def get_except_id
  Common.safe_read(DATA_DIR + '/except_id' + DATA_EXT).split("\n")
end

app_data = Common.safe_read(DATA_DIR + '/app_data' + DATA_EXT).split("\n")


PASSWORD        = app_data[0]				         #}X^[pX[h(͉ʂւ̃OCp)
LOG_LIMIT	      = 60 * 60 * 24 * app_data[1].to_i #ۑÕ~bg(bŎw)(𒴂ƌÂ玩폜)
COOKIE_TIME     = LOG_LIMIT   							 #NbL[̗L(b *  *  * )
SHOW_LOG_COUNT  = app_data[2].to_i					 #ʂɕ\郍O
SHOW_ITEM_COUNT = app_data[3].to_i           #1ʂɕ\鍀ڐ
EXCEPT_ID	      = get_except_id							 #OID
OS_NAMES        = get_os_names							 #OSꗗ
BROWSER_NAMES   = get_browser_names					 #uEUꗗ
SEARCHENGIN_NAMES = get_searchengin_names		 #GWꗗ
PAGE_NAMES      = get_page_names						 #y[Wꗗ

TITLE_COLOR      = app_data[4]
BACK_COLOR       = app_data[5]
MENU_COLOR       = app_data[6]
BODY_COLOR       = app_data[7]
BODY_BACK_COLOR  = app_data[8]
WEEK_BACK_COLOR  = app_data[9]
GRAPH_BACK_COLOR = app_data[10]
CELL_BACK_COLOR  = app_data[11]
BODY_TEXT_COLOR  = app_data[12]
MENU_TEXT_COLOR  = app_data[13]
TITLE_TEXT_COLOR = app_data[14]
LINK_COLOR       = app_data[15]
HLINK_COLOR      = app_data[16]
ITEM_COLOR       = app_data[17]
GRAPH_COLOR_NUM  = app_data[18]




#ȉhtml^O` DɃJX^}CYOK

COPYRIGHT_HTML = '<center>url : <a href="http://www.runread.com">http://www.runread.com/</a><BR>Copyright (c) 2007-' + Time.now.strftime("%Y") + ' RR All Rights Reserved.</center>'

ANALYZER_TITLE_HTML = '<div class="cell_title"><b>ACS Analyzer</b> version' + VERSION + '</div>'

BODY_HTML      = '<body bgcolor="' + BACK_COLOR + '" text="#ffffff" link="' + LINK_COLOR + '" vlink="' + LINK_COLOR + '" alink="' + LINK_COLOR + '">'

HEAD_HTML      =
'
<head>
<meta http-equiv="content-type" content="text/html; charset=Shift_JIS">
<meta http-equiv="content-style-type" content="text/css">

<style type="text/css">
<!--
body,tr,td,th {
font-size:13px;
font-family:"MS UI Gothic","lr oSVbN",Osaka;
color:		  	  ' + BODY_TEXT_COLOR + ';

margin-left:	  			33px;
margin-top:	  				8px;
margin-right: 	  			33px;
margin-bottom:	  			8px;
	
scrollbar-base-color : 		#000000;
scrollbar-face-color : 		#46484d; 
scrollbar-track-color: 		#070610;
scrollbar-arrow-color : 	#000000; 
scrollbar-3dlight-color: 	#000000;
scrollbar-darkshadow-color :#000000;
scrollbar-highlight-color : #86888d; 
scrollbar-shadow-color : 	#000000;
}

table{
	border-width: 	  0px;
}

.cell_title{
text-align:	  	  center;
font-family:  	  "MS UI Gothic";
font-size:        10pt;
font-weight:      normal;
color:		  	  ' + TITLE_TEXT_COLOR + ';
	
padding:          2px 2px 2px 2px;
margin:		  	    0px 0px 0px 0px;

border-style:	  solid;
border-width:     0px 0px 0px 0px;
border-color: 	  #575960;
background-color: ' + TITLE_COLOR + ';
}

.cell_menu{
text-align:	  	  left;
font-family:  	  "MS UI Gothic";
font-size:        10pt;
font-weight:      normal;
color:		  	  ' + MENU_TEXT_COLOR + ';
	
padding:          2px 2px 2px 2px;
margin:		  	    0px 0px 0px 0px;

border-style:	  solid;
border-width:     0px 0px 0px 0px;
border-color: 	  #575960;
background-color: ' + MENU_COLOR + ';
}

.cell_back{
text-align:	  	  left;
font-family:  	  "MS UI Gothic";
font-size:        10pt;
font-weight:      normal;
color:		  	  ' + BODY_TEXT_COLOR + ';
	
padding:          0px 0px 0px 0px;
margin:		  	    0px 0px 0px 0px;

border-style:	  solid;
border-width:     0px 0px 0px 0px;
border-color: 	  #575960;
background-color: ' + BODY_BACK_COLOR + ';
}

.cell_body{
text-align:	  	  left;
font-family:  	  "MS UI Gothic";
font-size:        10pt;
font-weight:      normal;
color:		  	  ' + BODY_TEXT_COLOR + ';
	
padding:          2px 2px 2px 2px;
margin:		  	    0px 0px 0px 0px;

border-style:	  solid;
border-width:     0px 0px 0px 0px;
border-color: 	  #575960;
background-color: ' + BODY_COLOR + ';
}

.cell_body2{
text-align:	  	  left;
font-family:  	  "MS UI Gothic";
font-size:        10pt;
font-weight:      normal;
color:		  	  	' + BODY_TEXT_COLOR + ';
	
padding:          2px 2px 2px 2px;
margin:		  	    0px 0px 0px 0px;

border-style:	  solid;
border-width:     0px 0px 0px 0px;
border-color: 	  #575960;
background-color: ' + GRAPH_BACK_COLOR + ';
}

a:hover  { color: ' + HLINK_COLOR + '; }

.num { font-family:Verdana,Helvetica,Arial; }
.l { background-color: #666666; color: #ffffff; }
.r { background-color: #ffffff; color: #000000; }
-->
				
</style>
<title>ACS Analyzer</title>
</head>
'





