#--------------------------------------------------------
# Ruby for ACS Analyzer             ver1.10b RR 2007-2009
# user
#
# url   : http://www.runread.com/
# e-mail: info@runread.com
#--------------------------------------------------------
STDOUT.sync=true

require 'settings.rb'
require 'common.rb'



class User

extend Common
include Common

BLANK_REC_PATH = LOG_DIR + '/blank_rec' + USER_EXT
USER_PATH      = LOG_DIR + '/user' + USER_EXT
USER_REC_SIZE  = 10

protected
  #--- 󂫃R[h擾 -------------------
  def User.get_blank_rec
	  self.safe_read(BLANK_REC_PATH, 'rb').unpack('L*')
  end

  #--- R[h擾 -------------------------
  def User.size
    File.size(USER_PATH) / USER_REC_SIZE
  end

public
  #--- ~bgzID㏑\ɂ ---
  def User.delete_limit
    no = []
  	nowtime = Time.now.to_i
    tmp = self.safe_read(USER_PATH, 'rb')
  	cnt = tmp.size / USER_REC_SIZE
  	a = tmp.unpack('LSL' * cnt)

    cnt.times{|i|
    	if nowtime - a[3 * i + 2] > LOG_LIMIT
    		no.push(i)
      end
    }
    																				#㏑\IDNoblank_recɕۑ
    self.safe_write(BLANK_REC_PATH, 'wb', no.pack('L*'))
  end

  #--- IDݏ -------------------------
  def User.write(no, id, vcount, hashsrc)
    File.open(USER_PATH, 'r+b'){|f|
      f.flock(File::LOCK_EX)
      
      usize = User.size
      blank_rec = User.get_blank_rec
      newflag = true
      
      if no >= 0 && no < usize                               #wnoL͈͓Ȃ
        f.seek(no * USER_REC_SIZE, File::SEEK_SET)
        if id.to_i == f.read(USER_REC_SIZE).unpack('LSL')[0] #wnoɂidƍvΗLȃNbL[Ɣf
          f.seek(no * USER_REC_SIZE, File::SEEK_SET)
          newflag = false
        end
      end
      
      if newflag                                #VK݂truȅꍇ
        if blank_rec.size > 0                   #󂫃R[hꍇ͂ɏ㏑
          f.seek(blank_rec[0] * USER_REC_SIZE, File::SEEK_SET)
          no = blank_rec[0]
          blank_rec.shift
          self.safe_write(BLANK_REC_PATH, 'wb', blank_rec.pack('L*'))
        else                                    #󂫃R[hȂΐVɍ쐬
          no = usize
          f.seek(0, File::SEEK_END)
        end                                     #32bit̃nbVlŎID肷
        id = sprintf("%010u", hashsrc.hash)
                                                #MD5(ANZXd鋰ꂪꍇ͂)
        #id = Digest::MD5.new(hashsrc).hexdigest[0..9]
      end
      
      f.write([id.to_i, vcount.to_i, Time.now.to_i].pack('LSL'))
      
      #f.flock(File::LOCK_UN)
    }
    
    [no, id]                                    #noid(nbVl)Ԃ
  end



  #--- wIDQ -------------------
  def [](id)
    if @no[id] != nil
      n = @no[id] * 3
      [@data[n + 1], @data[n + 2]]
    else
      nil
    end
    
    #@data[id]
  end
  
  #---  ---------------------------------
  def initialize
    @no = {}
    #@data = {}
    
    tmp = self.safe_read(USER_PATH, 'rb')
    cnt = tmp.size / USER_REC_SIZE
    
    @data = tmp.unpack('LSL' * cnt)
    cnt.times{|i| @no[@data[3 * i]] = i }  #xDׂ̈ɋ̍c OɍŏNof[^L^lɂƂ΂悩c
    
    #a = tmp.unpack('LSL' * cnt)
    #cnt.times{|i| @data[a[3 * i]] = [a[3 * i + 1], a[3 * i + 2]] }
  end
end






